/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: UserKeyStoreInfo.java 9137 2006-09-27 01:41:57Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.applications.signerclient;

import java.io.File;

/**
 * @version $Rev: 9137 $ $Date: 2006-09-27 08:41:57 +0700 (Wed, 27 Sep 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
public class UserKeyStoreInfo {

	private File keyStoreFile;
	private String keyStorePassword;

    private UserKeyStoreInfo(File keyStoreFile, String ksPassword) {
    	super();
    	this.keyStoreFile = keyStoreFile;
    	this.keyStorePassword = ksPassword;
    }

    public static UserKeyStoreInfo parse(String[] params) {

    	if (params.length < 2)
    		return null;

    	String path = params[0];
    	String pw = params[1];

        return new UserKeyStoreInfo(new File(path), pw);
    }

    public File getFile() {
        return keyStoreFile;
    }

    public String getPassword() {
        return keyStorePassword;
    }

}
