/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: EnclosingDigest.java 9137 2006-09-27 01:41:57Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.applications.signerclient.crypto.jce;

import org.bouncycastle.crypto.Digest;

/**
 * @version $Rev: 9137 $ $Date: 2006-09-27 08:41:57 +0700 (Wed, 27 Sep 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
class EnclosingDigest implements Digest {

	private byte[] digest;

	private String algorithmName;

    public EnclosingDigest(byte[] hash, String algorithm) {
	    super();
	    this.digest = hash;
	    this.algorithmName = algorithm;
    }

	/* (non-Javadoc)
	 * @see org.bouncycastle.crypto.Digest#doFinal(byte[], int)
	 */
	public int doFinal(byte[] hash, int offset) {
		int size = getDigestSize();
		System.arraycopy(digest, 0, hash, offset, size);
		return size;
	}

	/* (non-Javadoc)
	 * @see org.bouncycastle.crypto.Digest#getAlgorithmName()
	 */
	public String getAlgorithmName() {
		return algorithmName;
	}

	/* (non-Javadoc)
	 * @see org.bouncycastle.crypto.Digest#getDigestSize()
	 */
	public int getDigestSize() {
		return digest.length;
	}

	/* (non-Javadoc)
	 * @see org.bouncycastle.crypto.Digest#reset()
	 */
	public void reset() { }

	/* (non-Javadoc)
	 * @see org.bouncycastle.crypto.Digest#update(byte)
	 */
	public void update(byte in) { }

	/* (non-Javadoc)
	 * @see org.bouncycastle.crypto.Digest#update(byte[], int, int)
	 */
	public void update(byte[] in, int offset, int len) { }

}
