/***************************************************************************
 * Copyright 2001-2006 The eXo Platform SAS         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.faces.cms.validator;

import java.text.ParseException;
import java.util.ResourceBundle;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.Util;
import org.quartz.CronTrigger;

/**
 * Created by The eXo Platform SAS
 * Author : Pham Xuan Hoa
 *          hoa.pham@exoplatform.com
 * Dec 25, 2006  
 */
public class QuartzCronExpressionValidator implements Validator{

  public void validate(FacesContext context, UIComponent component, Object value) throws ValidatorException {
    ResourceBundle res =  Util.getApplicationResourceBundle()  ;
    String cronExpression = (String)value ;
    try {
      new CronTrigger().setCronExpression(cronExpression) ;
    }catch (ParseException pe) {
      throw new ValidatorException(new ExoFacesMessage(pe.getLocalizedMessage())) ;
    }    
  }

}
