/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.contentbrowser.component;

import javax.portlet.PortletPreferences;

import org.exoplatform.faces.FacesUtil;
import org.exoplatform.faces.cms.component.JcrBrowser;
import org.exoplatform.faces.core.component.UIPortlet;


/**
 * Created by The eXo Platform SARL
 * Author : HoaPham
 *          phamvuxuanhoa@yahoo.com
 * Jan 20, 2006
 */
public class UIContentBrowserConfig extends UIPortlet {        

  public UIContentBrowserConfig() throws Exception {    
    setId("ContentBrowserConfig") ;
    setRendererType("ChildrenRenderer");  

    JcrBrowser jcrBrowser = (JcrBrowser)addChild(JcrBrowser.class) ;
    jcrBrowser.setRendered(false) ;
    UIPathConfig pathConfig = (UIPathConfig)addChild(UIPathConfig.class) ;
    pathConfig.setRendered(false) ;    
    UIScriptConfig scriptConfig = (UIScriptConfig)addChild(UIScriptConfig.class) ;
    scriptConfig.setRendered(false) ;    
    UIQueryConfig queryConfig = (UIQueryConfig)addChild(UIQueryConfig.class) ;
    queryConfig.setRendered(false) ;    
    UIDocumentConfig documentConfig = (UIDocumentConfig)addChild(UIDocumentConfig.class) ;
    documentConfig.setRendered(false) ;   
    addChild(UINewConfigForm.class).setRendered(false) ;
    PortletPreferences prefs = FacesUtil.getPortletPreferences();
    String usecase_ = prefs.getValue(CBUtils.USECASE,"") ;
    if(usecase_.equals(CBUtils.FORM_PATH)) {
      pathConfig.updateFormValues() ;
      pathConfig.setEditable(false) ;      
      pathConfig.setRendered(true) ;      
    }else if (usecase_.equals(CBUtils.USE_JCR_QUERY)) {
      queryConfig.updateFormFields() ;
      queryConfig.setEditable(false) ;      
      queryConfig.setRendered(true) ;
    }else if ( usecase_.equals(CBUtils.USE_SCRIPT)) { 
      scriptConfig.updateFormValues() ;
      scriptConfig.setEditable(false) ;
      scriptConfig.setRendered(true) ;      
    }else if(usecase_.equals(CBUtils.USE_DOCUMENT)) {
      documentConfig.updateFormValues() ;
      documentConfig.setEditable(false) ;      
      documentConfig.setRendered(true) ;
    }
  }          
}
