/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.jcr;

import java.io.IOException;

import javax.jcr.Node;
import javax.jcr.Property;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.exoplatform.commons.utils.ExceptionUtil;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.container.RootContainer;
import org.exoplatform.services.ticket.TicketService;
/**
 * Created by The eXo Platform SARL        .
 * Sun, Dec 28, 2003 @ 14:57 
 * @author: Tuan Nguyen
 * @version: $Id: FileContentServlet.java,v 1.3 2004/06/23 03:19:01 tuan08 Exp $
 * @email: tuan08@yahoo.com
 */
public class TicketServlet extends HttpServlet {
  public void init(ServletConfig config) throws ServletException {}
  
	public void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    response.setHeader("Cache-Control", "private max-age=600, s-maxage=120");
    try { 
      String ticketId = request.getParameter("ticketId") ;
      String portalName = request.getParameter("portalId") ;
      PortalContainer pcontainer = getPortalContainer(portalName) ;
      PortalContainer.setInstance(pcontainer) ;
      response.setContentType("text/html") ;
      TicketService tservice = 
        (TicketService) pcontainer.getComponentInstanceOfType(TicketService.class) ;
      Object object = tservice.executeTicketCommand(ticketId) ;      
      try {
        Node child = (Node)object ;
        Property prop = child.getProperty("jcr:primaryType") ;
        String nodeProp = prop.getValue().getString() ; 
        if(nodeProp.equals("nt:unstructured")) {
          response.getWriter().write("NODE TYPE: " + nodeProp ) ;
        }else if(nodeProp.equals("nt:file")){
          response.getWriter().write("<div> NODE TYPE: " + nodeProp + "</div>") ;
        }else if(nodeProp.equals("exo:article")){
          response.getWriter().write("<div>NODE TYPE: " + nodeProp +"</div>") ;
          String title = child.getProperty("exo:title").getValue().getString() ;
          response.getWriter().write("<div style='font-weight:bold'>Title: " + title + "</div>") ;
          String summary = child.getProperty("exo:summary").getValue().getString() ;
          response.getWriter().write("<div style='font-weight: bold'>Summary: </div>") ;
          response.getWriter().write("<div>" + summary + "</div>") ;
          String content = child.getProperty("exo:text").getValue().getString() ;
          response.getWriter().write("<div style='font-weight: bold'>Content: </div>") ;
          response.getWriter().write("<div>" + content + "</div>") ;
        }else {
          response.getWriter().write("NO SUPPORTED NODE TYPE: " + nodeProp ) ;
        }
      }catch(Exception e) {
        String errorCode = (String)object ;
        if(errorCode.equals("1"))
          response.getWriter().write("TICKET " + ticketId + " EXPIRED BY ACCESS TIME" ) ;
        if(errorCode.equals("2"))          
          response.getWriter().write("TICKET " + ticketId + " EXPIRED BY LIMIT ACCESS" ) ;
      }
		} catch (Exception ex) {
			ex.printStackTrace() ;	
			String s = ExceptionUtil.getStackTrace(ex, 20) ;
      response.getOutputStream().println(s) ;
		} finally {
			PortalContainer.setInstance(null) ;
		}
	}
  
  private  PortalContainer getPortalContainer(String portalName) {
    PortalContainer pcontainer =  RootContainer.getInstance().getPortalContainer(portalName) ;
    return pcontainer ;
  }
}
