/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.jcr.component;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.util.ArrayList;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.jcr.Node;
import javax.jcr.Session;
import javax.servlet.http.HttpServletResponse;

import org.exoplatform.commons.utils.ExoExpression;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.core.component.UICheckBox;
import org.exoplatform.faces.core.component.UIRadioBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portlets.content.jcr.component.UIViewController.CancelActionListener;
import org.exoplatform.services.compress.CompressData;
import org.exoplatform.services.download.DownloadResource;
import org.exoplatform.services.download.DownloadService;
import org.exoplatform.services.download.InputStreamDownloadResource;
/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id$
 */
public class UIExport extends UISimpleForm implements ChangeNodeListener {
  private Session session_ ;
  private String nodePath_ ;
  
  public UIExport() {
    super("uiExport", "post", null);        
    setId("UIExport") ;
    setRendererType("SimpleFormVelocityRenderer") ;
    UIStringInput nodePath = new UIStringInput("nodePath", "") ;
    nodePath.setValue(nodePath_) ;
    nodePath.isReadonly() ;
    add(nodePath) ;    
    List<SelectItem> formatItem = new ArrayList<SelectItem>() ;  
    formatItem.add(new SelectItem("Document view", "docview")) ;
    formatItem.add(new SelectItem("System view", "sysview")) ;
    UIRadioBox format = new UIRadioBox("format", "docview", formatItem) ;
    format.setAlign(UIRadioBox.VERTICAL_ALIGN) ;
    add(format) ;
    UICheckBox zipOption = new UICheckBox("zip","Zip the document") ;
    zipOption.setSelect(false) ;
    add(zipOption) ;
    addActionListener(ExportActionListener.class, SAVE_ACTION) ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION) ;
  }
  
  public String getPath() { return nodePath_ ; }
  
  public void  onChange(UIJCRExplorer uiExplorer, Node node)  throws Exception {
    session_ = uiExplorer.getSession() ;
    nodePath_ = node.getPath() ;
    setRendered(false) ;
  }
  
  public String getWorkspace() {
    return session_.getWorkspace().getName() ;
  }
  
  public String  cancelAction() {        
    return CANCEL_ACTION ; 
  }
  
  static public class ExportActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIExport uiForm = (UIExport)event.getSource() ;
      CompressData zipService = new CompressData();
      DownloadService dservice =
        (DownloadService) PortalContainer.getComponent(DownloadService.class);
      DownloadResource dresource ;
      FacesContext ctx = uiForm.getFacesContext();
      String format = uiForm.getUIRadioBox("format").getValue() ;
      boolean isZip = uiForm.getUICheckBox("zip").getSelect() ;
      ByteArrayOutputStream bos = new ByteArrayOutputStream() ;
      if (isZip) {
        ExoExpression.setEntry(format+".xml");
        if(format.equals("docview")){
          uiForm.session_.exportDocumentView(uiForm.nodePath_, bos, false, false ) ;
        }else {
          uiForm.session_.exportSystemView(uiForm.nodePath_, bos, false, false ) ;
        }
        ByteArrayInputStream input = new ByteArrayInputStream(bos.toByteArray()) ;
        zipService.addInputStream("docview.xml",input);
        zipService.createZip(bos);
        ByteArrayInputStream zipInput = new ByteArrayInputStream(bos.toByteArray());
        dresource = new InputStreamDownloadResource(zipInput, "application/zip") ;
        dresource.setDownloadName( format + ".zip");
        
      }else {
        if(format.equals("docview")){
          uiForm.session_.exportDocumentView(uiForm.nodePath_, bos, false, false ) ;
        }else {
          uiForm.session_.exportSystemView(uiForm.nodePath_, bos, false, false ) ;
        }
        
        ByteArrayInputStream is = new ByteArrayInputStream(bos.toByteArray()) ;
        dresource = new InputStreamDownloadResource(is, "text/xml") ;
        dresource.setDownloadName( format + ".xml");
      }
      String downloadId = dservice.addDownloadResource(dresource) ;
      String downloadLink = dservice.getDownloadLink(downloadId) ;
      HttpServletResponse response =(HttpServletResponse)ctx.getExternalContext().getResponse();      
      response.sendRedirect(downloadLink);
      ctx.responseComplete();      
    }   
  }
}
