/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.jcr.component;

import java.util.Map;
import java.util.ResourceBundle;

import javax.faces.application.FacesMessage;
import javax.jcr.Node;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.cms.CMSDialogComponent;
import org.exoplatform.faces.cms.CMSUtils;
import org.exoplatform.faces.core.component.UISimpleMulltipartForm;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;
import org.exoplatform.portlets.content.jcr.JCRExceptionManager;
import org.exoplatform.services.cms.CmsService;
import org.exoplatform.services.cms.metadata.MetadataService;

/**
 * @email: nguyenkequanghung@yahoo.com
 * @version: $Id: UIContentDisplayer.java,v 1.2 2006/04/04
 */
public class UIMetadataForm extends UISimpleMulltipartForm implements CMSDialogComponent, ChangeNodeListener {
  
  private String metatypeName_;
  protected Node node_;  
  private MetadataService mservice_;

  public UIMetadataForm(MetadataService mservice) throws Exception {

    super("uiMetadataForm", "post", null);
    setRendererType("SimpleFormVelocityRenderer");

    mservice_ = mservice;    

    addActionListener(SaveMetadataActionListener.class, SAVE_ACTION);
    addActionListener(CancelActionListener.class, CANCEL_ACTION);   
  }
  
  public void onChange(UIJCRExplorer uiExplorer, Node node) throws Exception {    
    setRendered(false);
  }

  public void update(Node node,String metatypeName) {
    this.node_ = node ;    
    this.metatypeName_ = metatypeName ;
  }
  
  public String getMetaDialogTemplatePath() throws Exception {    
    return mservice_.getMetadataTemplatePath(metatypeName_,true) ;
  }
  public String getMetatypeName() { return metatypeName_ ; }
  public Node getNode() { return node_; }   

  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIMetadataForm uicomp = (UIMetadataForm) event.getSource();
      uicomp.setRenderedSibling(UIMetadataInfo.class) ;
    }
  }

  static public class SaveMetadataActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIMetadataForm uiForm = (UIMetadataForm) event.getSource();      
      String metaTypeName = uiForm.getMetatypeName() ;
      Node node = uiForm.getNode() ;               
      Map mappings = CMSUtils.prepareMap(uiForm) ;
      CmsService cmsService = (CmsService)PortalContainer.getComponent(CmsService.class) ;
      Information iprovider = findInformationProvider(uiForm) ;
      ResourceBundle res = getApplicationResourceBundle() ;      
      try {        
        cmsService.storeNodeContent(node,metaTypeName,mappings) ;
        node.save();
        node.getSession().save();              
      } catch (Exception e) {
        JCRExceptionManager.process(iprovider,e) ;
        return ;
      }
      Object[] arg = {metaTypeName} ;        
      iprovider.addMessage(new ExoFacesMessage(FacesMessage.SEVERITY_INFO,
          res.getString("UIMetadataForm.msg.add-successfully"),arg));
      uiForm.setRenderedSibling(UIMetadataInfo.class) ;
    }    
  }     
}