/***************************************************************************
 * Copyright 2001-2007 The eXo Platform SAS         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.jcr.component;

import java.util.ArrayList;
import java.util.List;

import javax.jcr.Node;
import javax.jcr.Value;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.core.component.UIRadioBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;
import org.exoplatform.portlets.content.jcr.JCRExceptionManager;
import org.exoplatform.portlets.content.jcr.component.UIViewController.CancelActionListener;
import org.exoplatform.services.cms.voting.VotingService;

/**
 * Created by The eXo Platform SAS
 * Author : Pham Xuan Hoa
 *          hoa.pham@exoplatform.com
 * Jan 17, 2007  
 */
public class UIVotingForm extends UISimpleForm implements ChangeNodeListener{
  
  private UIRadioBox ratingSelection_ ;
  private Node votingDocument_ ;    
  
  public UIVotingForm() {
    super("VotingForm", "post", null);
    setRendererType("SimpleFormVelocityRenderer");    
    
    List<SelectItem> ratingOptions = new ArrayList<SelectItem>() ;
    ratingOptions.add(new SelectItem("Nomal",    "1")) ;
    ratingOptions.add(new SelectItem("Good",     "2")) ;
    ratingOptions.add(new SelectItem("Very good","3")) ;
    ratingOptions.add(new SelectItem("Best",     "4")) ;
    ratingOptions.add(new SelectItem("Excellent","5")) ;
    
    ratingSelection_ = new UIRadioBox("rating","",ratingOptions) ;
    ratingSelection_.setAlign(UIRadioBox.VERTICAL_ALIGN) ;
    add(ratingSelection_) ;
    
    addActionListener(SaveActionListener.class,SAVE_ACTION) ;
    addActionListener(CancelActionListener.class,CANCEL_ACTION) ;    
  }
    
  public Node getDocument() { return votingDocument_ ; }  
  public void setDocument2Vote(Node document) {
    this.votingDocument_ = document ;
  }
      
  public List<String> getVoters() throws Exception {
    List<String> voterList = new ArrayList<String>() ;
    if(!votingDocument_.isNodeType("mix:votable")) return voterList ;
    Value[] votersArray = votingDocument_.getProperty("exo:voter").getValues() ;    
    for(Value voter:votersArray) {
      voterList.add(voter.getString()) ;
    }
    return voterList ;
  }
    
  public void onChange(UIJCRExplorer uiExplorer, Node node) throws Exception {
    this.setRendered(false) ;
  }
  
  public static class SaveActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIVotingForm uicomp = (UIVotingForm)event.getComponent() ;
      UIRadioBox radioBox = uicomp.getUIRadioBox("rating") ;
      String rating = radioBox.getValue() ;
      if(rating == null || rating.length() == 0) {
        return ;
      }
      double selectedRate  = Double.parseDouble(radioBox.getValue()) ; 
      VotingService votingService = 
        (VotingService)PortalContainer.getComponent(VotingService.class) ;      
      Node document = uicomp.getDocument() ;
      try{                        
        votingService.vote(document,selectedRate) ;   
      }catch(Exception e) {               
        Information iprovider = findInformationProvider(uicomp) ;
        JCRExceptionManager.process(iprovider,e) ;
      }
    }    
  }
      
}
