package org.exoplatform.portlets.content.metadata.component;

import java.util.ArrayList;
import java.util.List;

import javax.jcr.Node;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeIterator;
import javax.jcr.nodetype.NodeTypeManager;

import org.exoplatform.faces.core.Selector;
import org.exoplatform.faces.core.SelectorHandler;
import org.exoplatform.faces.core.component.UISelectBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.UITextArea;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.faces.user.component.UIExoPermissionBrowser;
import org.exoplatform.faces.user.component.UIExoPermissionSelector;
import org.exoplatform.portal.Information;
import org.exoplatform.portlets.content.jcr.JCRExceptionManager;
import org.exoplatform.services.cms.BasePath;
import org.exoplatform.services.cms.CmsConfigurationService;
import org.exoplatform.services.cms.metadata.MetadataService;
import org.exoplatform.services.cms.scripts.ScriptService;
import org.exoplatform.services.jcr.RepositoryService;

/**
 * @email:   nguyenkequanghung@yahoo.com
 * @version: $Id: UIMappingMetadataForm.java,v 1.2 2006/04/04
 */
public class UIMappingMetadataForm extends UISimpleForm implements SelectorHandler{

  static String WIZARD_PRENODESAVE = "PreNodeSave", WIZARD_POSTNODESAVE = "PostNodeSave",
  WIZARD_NODETYPE = "nodetype", WIZARD_MIXINTYPE = "mixintype",
  WIZARD_SCRIPT = "script", WIZARD_WIDGET = "widget",
  WIZARD_EDITABLE = "editable", WIZARD_VISIBLE = "visible",
  WIZARD_INPUTNAME = "inputName", WIZARD_JCRPATH = "jcrPath",
  WIZARD_OPTIONS = "options", WIZARD_SELECTORACTION = "selectorAction",
  WIZARD_SELECTORCLASS = "selectorClass", WIZARD_SELECTORLABEL = "selectorLabel",
  WIZARD_SELECTORPARAMS = "selectorParams", WIZARD_SCRIPTPARAMS = "scriptParams",
  WIZARD_MULTIVALUES = "multiValues", WIZARD_DEFAULTVALUE = "defaultValue",
  WIZARD_LABEL = "label", WIZARD_TITLEWIZARD = "title";

  protected UISelectBox wizard_PreNodeSave_ ;
  protected UISelectBox wizard_PostNodeSave_ ;
  protected UISelectBox wizard_nodetype_ ;
  protected UISelectBox wizard_mixintype_ ;
  protected UISelectBox wizard_script_ ;
  protected UISelectBox wizard_widget_ ;
  protected UISelectBox wizard_editable_ ;
  protected UISelectBox wizard_visible_ ;
  protected UIStringInput wizard_label_;
  protected UIStringInput wizard_inputName_;
  protected UIStringInput wizard_jcrPath_;
  protected UIStringInput wizard_options_;
  protected UIStringInput wizard_selectorAction_;
  protected UIStringInput wizard_selectorClass_;
  protected UIStringInput wizard_selectorLabel_;
  protected UIStringInput wizard_selectorParams_;
  protected UIStringInput wizard_scriptParams_;
  protected UIStringInput wizard_multiValues_;
  protected UIStringInput wizard_defaultValue_;
  protected UIStringInput wizard_titleWizard_;  

  static String  SEARCH_GROUP = "searchGroup" ;
  private MetadataService mservice_ ;  
  private String metatypeName_ ;
  private UIExoPermissionSelector permSelector_;
  private boolean isAddNew_ = true ;
  List<String> mixinNodetypeName_ = new ArrayList<String>() ;

  protected ScriptService scriptService_;
  protected CmsConfigurationService cmsConfigService_;
  protected RepositoryService repositoryService_;

  public UIMappingMetadataForm(MetadataService mservice,ScriptService scriptService,
      CmsConfigurationService cmsConfigService,RepositoryService repoService) throws Exception{    
    super("uiMappingMetadataForm", "post", null);
    setRendererType("SimpleFormVelocityRenderer");    
    mservice_ = mservice ;
    cmsConfigService_ = cmsConfigService ;
    repositoryService_ = repoService ;
    scriptService_ = scriptService ;

    UITextArea dialog = new UITextArea("dialog", "") ;
    add(dialog) ;
    UITextArea view = new UITextArea("view", "") ;
    add(view) ;

    wizard_PreNodeSave_= new UISelectBox(WIZARD_PRENODESAVE,"", new ArrayList<SelectItem>());
    add(wizard_PreNodeSave_);
    wizard_PostNodeSave_= new UISelectBox(WIZARD_POSTNODESAVE,"", new ArrayList<SelectItem>());
    add(wizard_PostNodeSave_);
    wizard_nodetype_ = new UISelectBox(WIZARD_NODETYPE,"", new ArrayList<SelectItem>());
    add(wizard_nodetype_);
    wizard_mixintype_ = new UISelectBox(WIZARD_MIXINTYPE,"", new ArrayList<SelectItem>());
    add(wizard_mixintype_);
    wizard_editable_ = new UISelectBox(WIZARD_EDITABLE,"", new ArrayList<SelectItem>());
    add(wizard_editable_);
    wizard_visible_ = new UISelectBox(WIZARD_VISIBLE,"", new ArrayList<SelectItem>());
    add(wizard_visible_);
    wizard_script_ = new UISelectBox(WIZARD_SCRIPT,"", new ArrayList<SelectItem>());
    add(wizard_script_);
    wizard_widget_ = new UISelectBox(WIZARD_WIDGET,"", new ArrayList<SelectItem>());
    add(wizard_widget_);
    wizard_label_ = new UIStringInput(WIZARD_LABEL, "");
    add(wizard_label_);
    wizard_inputName_ = new UIStringInput(WIZARD_INPUTNAME, "");
    add(wizard_inputName_);
    wizard_jcrPath_ = new UIStringInput(WIZARD_JCRPATH, "/node/");
    add(wizard_jcrPath_);
    wizard_options_ = new UIStringInput(WIZARD_OPTIONS, "");
    add(wizard_options_);
    wizard_scriptParams_ = new UIStringInput(WIZARD_SCRIPTPARAMS, "");
    add(wizard_scriptParams_);
    wizard_selectorAction_ = new UIStringInput(WIZARD_SELECTORACTION, "");
    add(wizard_selectorAction_);
    wizard_selectorClass_ = new UIStringInput(WIZARD_SELECTORCLASS, "");
    add(wizard_selectorClass_);
    wizard_selectorLabel_ = new UIStringInput(WIZARD_SELECTORLABEL, "");
    add(wizard_selectorLabel_);
    wizard_selectorParams_ = new UIStringInput(WIZARD_SELECTORPARAMS, "");
    add(wizard_selectorParams_);
    wizard_multiValues_ = new UIStringInput(WIZARD_MULTIVALUES, "");
    add(wizard_multiValues_);
    wizard_defaultValue_ = new UIStringInput(WIZARD_DEFAULTVALUE, "");
    add(wizard_defaultValue_);
    wizard_titleWizard_ = new UIStringInput(WIZARD_TITLEWIZARD, "");
    add(wizard_titleWizard_);

    permSelector_ = new UIExoPermissionSelector("viewPermission", null) ;
    add(permSelector_) ;
    addActionListener(SearchGroupActionListener.class, SEARCH_GROUP) ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION);
    addActionListener(SaveActionListener.class, SAVE_ACTION);        
  }

  public String getSearchGroup() { return SEARCH_GROUP; }
  public void cancel(Selector selector) {
    selector.setRenderedSibling(UIMappingMetadataForm.class) ;
  }

  public void select(Selector selector) throws Exception {
    UIExoPermissionBrowser browser = (UIExoPermissionBrowser)selector ;
    if(browser.isGroup()) {
      permSelector_.setPermission(selector.getInputValue());
    }else {
      permSelector_.setValue(browser.getSelectedUser()) ;
    }
    selector.setRenderedSibling(UIMappingMetadataForm.class);    
  }    

  public String getMetaTypeName() { return metatypeName_ ; }
  public void setMetaTypeName(String name) { this.metatypeName_ = name ; }

  public void update(String metadata)throws Exception {
    this.metatypeName_ = metadata ;
    String dialog = mservice_.getMetadataTemplate(metatypeName_, true) ;
    String view = mservice_.getMetadataTemplate(metatypeName_, false) ;
    String permission = null ;
    if((dialog == null ||dialog.length()==0) && (view == null)|| view.length() == 0) {
      this.isAddNew_ = true ; 
      dialog = "";
      view = "" ;
      permission = "" ;
    }else {
      this.isAddNew_ = false ;
      String[] roles = mservice_.getMetadataTemplateRoles(metatypeName_, true) ;
      StringBuffer temp = new StringBuffer() ;
      if(roles != null && roles.length>0) {
        for(String role:roles) {
          temp.append(role).append(";");
        }
      }                
      permission = temp.toString() ;
    }                      
    permSelector_.setValue(permission) ;
    getUIInput("dialog").setValue(dialog) ;
    getUIInput("view").setValue(view) ;
    updateWizard();
  }

  static public class SaveActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIMappingMetadataForm uiForm = (UIMappingMetadataForm) event.getSource();
      String metaType = uiForm.getMetaTypeName() ;
      String[] roles = uiForm.permSelector_.getValue().split(";") ;
      String dialog = uiForm.getUIInput("dialog").getValue() ;
      String view = uiForm.getUIInput("view").getValue() ;
      Information iprovider = findInformationProvider(uiForm) ;      
      try{
        if(dialog != null && dialog.length()>0)
          uiForm.mservice_.addMetadataTemplate(metaType, true, roles, dialog, uiForm.isAddNew_) ;
        if(view !=null && view.length()>0)
          uiForm.mservice_.addMetadataTemplate(metaType, false, roles, view, uiForm.isAddNew_) ; 
      }catch (Exception e) {
        JCRExceptionManager.process(iprovider,e) ;
        return ;
      }                  
      uiForm.setRenderedSibling(UIMetadataManager.class) ;
    }  
  }

  static public class SearchGroupActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIMappingMetadataForm uiForm = (UIMappingMetadataForm) event.getSource();
      UIExoPermissionBrowser uiGroupBrowser = 
        (UIExoPermissionBrowser) uiForm.getSibling(UIExoPermissionBrowser.class);           
      uiGroupBrowser.setHandler(uiForm);
      uiForm.setRenderedSibling(UIExoPermissionBrowser.class);  
    }
  } 

  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIMappingMetadataForm uiForm = (UIMappingMetadataForm) event.getSource();
      uiForm.setRenderedSibling(UIMetadataManager.class) ;
    }
  }

  public void updateWizardNodeSaveOptions() throws Exception {
    List<SelectItem> wizard_PreNodeSave_options = new ArrayList<SelectItem>();
    List<SelectItem> wizard_PostNodeSave_options = new ArrayList<SelectItem>();    
    String path = cmsConfigService_.getJcrPath(BasePath.CMS_SCRIPTS_PATH) ;      
    for(Node node:scriptService_.getECMInterceptorScripts()){        
      String interceptorPath = node.getPath().substring(path.length()+1);
      wizard_PreNodeSave_options.add(new SelectItem(interceptorPath ,interceptorPath));
      wizard_PostNodeSave_options.add(new SelectItem(interceptorPath ,interceptorPath));
    }
    wizard_PreNodeSave_.setOptions(wizard_PreNodeSave_options);
    wizard_PostNodeSave_.setOptions(wizard_PostNodeSave_options);    
  }

  public void updateWizardNodeTypeOptions() throws Exception {        
    List<SelectItem> options = new ArrayList<SelectItem>();
    options.add(new SelectItem("", ""));
    for(NodeType nt:getNodeTypeList()) {            
      options.add(new SelectItem(nt.getName(), nt.getName()));
    }
    wizard_nodetype_.setOptions(options) ;
  }

  public void updateWizardMixinTypeOptions() throws Exception {
    List<SelectItem> options = new ArrayList<SelectItem>();
    options.add(new SelectItem("", ""));
    for(NodeType nt:getNodeTypeList()) {
      if(nt.isMixin()){
        String ntName = nt.getName() ;
        options.add(new SelectItem(ntName, ntName));
      }
    }    
    wizard_mixintype_.setOptions(options);    
  }

  public void updateWizardScriptOptions() throws Exception {
    List<SelectItem> options = new ArrayList<SelectItem>();
    options.add(new SelectItem("", ""));
    String path = cmsConfigService_.getJcrPath(BasePath.CMS_SCRIPTS_PATH) ;    
    for(Node node:scriptService_.getECMWidgetScripts()){      
      String item = node.getPath().substring(path.length()+1);
      options.add(new SelectItem(item ,item));
    }
    wizard_script_.setOptions(options);    
  }

  public void updateWizardWidgetOptions() throws Exception {
    List<SelectItem> options = new ArrayList<SelectItem>();
    options.add(new SelectItem("", ""));
    options.add(new SelectItem("calendar", "calendar"));
    options.add(new SelectItem("selectbox", "selectbox"));
    options.add(new SelectItem("text", "text"));
    options.add(new SelectItem("textarea", "textarea"));
    options.add(new SelectItem("upload", "upload"));
    options.add(new SelectItem("wysiwyg", "wysiwyg"));
    wizard_widget_.setOptions(options);
  }
  public void updateWizardVisibleOptions() throws Exception {
    List<SelectItem> options = new ArrayList<SelectItem>();
    options.add(new SelectItem("true", "true"));
    options.add(new SelectItem("if-not-null", "if-not-null"));
    wizard_visible_.setOptions(options);
  }
  public void updateWizardEditableOptions() throws Exception {
    List<SelectItem> options = new ArrayList<SelectItem>();
    options.add(new SelectItem("true", "true"));
    options.add(new SelectItem("false", "false"));
    wizard_editable_.setOptions(options);
  }
  public void updateWizard() throws Exception {
    updateWizardNodeSaveOptions();
    updateWizardNodeTypeOptions();
    updateWizardMixinTypeOptions();
    updateWizardScriptOptions();
    updateWizardWidgetOptions();
    updateWizardVisibleOptions();
    updateWizardEditableOptions();
  }

  private List<NodeType> getNodeTypeList() throws Exception {
    NodeTypeManager ntManager = repositoryService_.getRepository().getNodeTypeManager() ;
    List<NodeType> nodeTypes = new ArrayList<NodeType>() ;
    for(NodeTypeIterator iter = ntManager.getAllNodeTypes(); iter.hasNext();) 
      nodeTypes.add(iter.nextNodeType()) ;    
    return nodeTypes ;
  }
}


