/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.script.component;

import java.util.ArrayList;
import java.util.List;

import org.exoplatform.faces.core.component.UISelectBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;

/**
 * Created by The eXo Platform SARL
 * Author : Hoa Pham
 *					hoa.pham@exoplatform.com
 *          phamvuxuanhoa@yahoo.com
 * May 17, 2006
 */
public class UIScriptFilterForm extends UISimpleForm {
  
  final static String CHANGE_TYPE_ACTION = "changeScriptType".intern() ;
  final static String SCRIPT_TYPE = "scriptType" ;
  private String selectedScriptType_ ;
  private UISelectBox scriptsBox_ ;
  
  public UIScriptFilterForm() throws Exception {
    super("scriptFilterForm", "post", null);
    setRendererType("SimpleFormVelocityRenderer");
    scriptsBox_ = new UISelectBox(SCRIPT_TYPE,"",new ArrayList<SelectItem>()) ;
    scriptsBox_.setUpdateOnChangeAction(CHANGE_TYPE_ACTION) ;
    add(scriptsBox_) ;
    
    addActionListener(ChangeScriptTypeActionListener.class,CHANGE_TYPE_ACTION) ;
  }
  
  public void updateForm(String defaultType, List<SelectItem> scriptOptions) throws Exception {
    selectedScriptType_ = defaultType ;
    scriptsBox_.setOptions(scriptOptions) ;
  }
  
  public String getSelectedScriptType() { return selectedScriptType_ ; }
  
  public void setSelectedScriptType(String scriptType) {    
    selectedScriptType_ = scriptType ;           
  }
  
  public String getSelectedScriptPrefix() {
    List<SelectItem> options = getUISelectBox(SCRIPT_TYPE).getOptions() ;
    for(SelectItem item:options) {
      if(selectedScriptType_.equals(item.display_)) {
        return item.value_ ;
      }
    }
    return "" ;
  }
  
  public static class ChangeScriptTypeActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIScriptFilterForm filterForm = (UIScriptFilterForm)event.getComponent() ;      
      String selectedItemValue = filterForm.getUISelectBox(SCRIPT_TYPE).getValue();      
      List<SelectItem> options = filterForm.getUISelectBox(SCRIPT_TYPE).getOptions() ;
      String selectedItemDisplay = "" ;
      for(SelectItem item:options) {     
        if(item.value_.equals(selectedItemValue)) { 
          selectedItemDisplay = item.display_;
          break ;
        }
      }     
      filterForm.setSelectedScriptType(selectedItemDisplay) ;
      UIECMScriptList ecmScriptList = (UIECMScriptList)filterForm.getParent();
      ecmScriptList.refresh();
    }    
  }
}
