/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.script.component;

import java.util.List;

import javax.jcr.Node;

import org.exoplatform.faces.core.component.UIExoComponentBase;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.services.cms.scripts.ScriptService;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 * @email:   jobdung@yahoo.com
 * @version: $Id: UIScriptFormController.java,v 1.0 2006/08/24 9:11:26 dunghoang Exp $
 */
public class UIScriptFormController extends UIExoComponentBase {
  protected ScriptService scriptService_;
  protected Node node_;
  public UIScriptFormController(ScriptService scriptService) throws Exception {
    scriptService_ = scriptService;    
    setRendererType("ChildrenRenderer") ;
    addChild(UISelectScriptVersionForm.class) ;
    addChild(UIScriptForm.class) ;
  }
 
  public void showEditScriptForm(boolean isECMScript, String scriptName,
      List<SelectItem> options, String selectedScriptTypeValue) throws Exception {            
    UISelectScriptVersionForm uiSelect = 
      (UISelectScriptVersionForm) getChildComponentOfType(UISelectScriptVersionForm.class);
    String name2get = selectedScriptTypeValue + "/" + scriptName ;
    node_ = scriptService_.getScriptNode(name2get);  
    boolean isVersioned = node_.isNodeType("mix:versionable");
    if (isVersioned) {
      uiSelect.setRendered(true) ; 
      uiSelect.setScript(isECMScript, scriptName, options, selectedScriptTypeValue);
    }else{
      uiSelect.setRendered(false) ;
    }           
    UIScriptForm scriptForm = (UIScriptForm) getChildComponentOfType(UIScriptForm.class);    
      scriptForm.setData(isECMScript, scriptName, options, selectedScriptTypeValue, null);   
  }

  public void showNewScriptForm(boolean isECMScript, List<SelectItem> options, String selectedScriptTypeValue) throws Exception {
    UISelectScriptVersionForm uiSelect = 
      (UISelectScriptVersionForm) getChildComponentOfType(UISelectScriptVersionForm.class);
    uiSelect.setRendered(false) ;
    UIScriptForm scriptForm = 
      (UIScriptForm) getChildComponentOfType(UIScriptForm.class);
    scriptForm.setData(isECMScript, null, options, selectedScriptTypeValue, null);
  }
  
}