/***************************************************************************
 * Copyright 2001-2007 The eXo Platform SAS         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.uploader.component;

import java.util.Map;
import java.util.ResourceBundle;

import javax.faces.application.FacesMessage;
import javax.jcr.Node;

import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.cms.CMSDialogComponent;
import org.exoplatform.faces.cms.CMSUtils;
import org.exoplatform.faces.core.component.UISimpleMulltipartForm;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;
import org.exoplatform.portlets.content.contentbrowser.component.ChangeNodeListener;
import org.exoplatform.portlets.content.contentbrowser.component.UIContentExplorer;
import org.exoplatform.services.cms.metadata.MetadataService;

/**
 * Created by The eXo Platform SAS
 * Author : Pham Xuan Hoa
 *          hoa.pham@exoplatform.com
 * May 11, 2007  
 */
public class UIMetadataDialogForm extends UISimpleMulltipartForm implements ChangeNodeListener, CMSDialogComponent {

  private String metaTypeName_ ;
  private MetadataService metaService_ ;
  private Node node_ ;

  public UIMetadataDialogForm(MetadataService metadataService) {
    super("metadataDialogForm", "post", null);
    setRendererType("SimpleFormVelocityRenderer");
    metaService_ = metadataService ;

    addActionListener(SaveActionListener.class,SAVE_ACTION) ;
    addActionListener(CancelActionListener.class,CANCEL_ACTION) ;

  }

  public String getMetaTypeName() { return metaTypeName_ ; }
  public void setMetaTypeName(String name) { this.metaTypeName_ = name ; }

  public String getMetaDialogTemplatePath() throws Exception {
    String metaPath = metaService_.getMetadataTemplatePath(metaTypeName_,true) ;
    if(metaPath == null) return null ;
    return "jcr:"+ metaPath;
  }  

  public void onChange(UIContentExplorer uiExplorer, Node node) throws Exception {
    this.node_ = uiExplorer.getSelectNode() ;
  }

  public Node getNode() throws Exception { return node_ ; } 
  public void setNode(Node node) { this.node_ = node ;  }

  static public class SaveActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIMetadataDialogForm metaForm = (UIMetadataDialogForm)event.getComponent();
      Map metaContentInputs = CMSUtils.prepareMap(metaForm) ;
      String metaTypeName = metaForm.getMetaTypeName() ;
      UIContentUploader controller = (UIContentUploader)metaForm.getSibling(UIContentUploader.class) ;
      controller.setSelectedMetaContent(metaTypeName,metaContentInputs) ;
      Information iprovider = findInformationProvider(metaForm) ;
      ResourceBundle res = getApplicationResourceBundle() ;      
      iprovider.addMessage(new ExoFacesMessage(FacesMessage.SEVERITY_INFO,
          res.getString("UIMetadataDialogForm.msg.add-successfully"),new Object[]{metaTypeName})) ;
      metaForm.setRenderedSibling(UIContentUploader.class) ;
    }     
  }    

  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIMetadataDialogForm metaForm = (UIMetadataDialogForm)event.getComponent();
      metaForm.setRenderedSibling(UIContentUploader.class) ;
    }    
  }
}
