package org.exoplatform.services.workflow.impl.oncepi;

/**
 *  by chencongwu
 *  2006.7.21
 */

import java.util.Date;
import java.text.SimpleDateFormat;
import java.text.ParseException;
import cn.ac.ios.tcse.isflow.WorkList.WorkListServer.ConnectionManager.TaskInfo;

import org.exoplatform.services.workflow.Task;

public class TaskData implements Task {

	private String actorId = null;

	private String description = null;

	private String id = null;

	private String processId = null;

	private String processInstanceId = null;

	private String taskName = null;

	private Date end = null;

	public TaskData(TaskInfo task){

		this.actorId = task.getTaskRole();
		this.description = task.getComment();
		this.id = task.getTaskInstanceId();
		this.processId = task.getPackageId()+task.getProcessTemplateId();
		this.processInstanceId = task.getProcessInstanceId();
		this.taskName = task.getTaskName();
		try{
		this.end = new SimpleDateFormat("yyyy/MM/dd hh:mm").parse(task.getDue());
		}catch (ParseException pe){
			System.out.println("Date Parse Error in TaskData!\n");
			this.end=null;
		}
	} 

	public String getActorId() {
		 
		return this.actorId;
	}

	public String getDescription() {
		 
		return this.description;
	}

	public String getId() {
		 
		return this.id;
	}

	public String getProcessId() {
		
		 return this.processId;
	}

	public String getProcessInstanceId() {
		 
		return  this.processInstanceId;
	}

	public String getTaskName() {
		 
		return this.taskName;
	}

	public Date getEnd() {
		 
		return this.end;
	}
	
	public String toString(){
		StringBuffer buf=new StringBuffer();
		buf.append("TaskData information: \n");
		buf.append(" actorid="+this.actorId);
		buf.append(" description="+this.description);
		buf.append(" id="+this.id);
		buf.append(" processid="+this.processId);
		buf.append(" processinstaceid="+this.processInstanceId);
		buf.append(" taskname="+this.taskName);
		buf.append(" end="+this.end);
		buf.append("\n");
		return buf.toString();
	}

	public static void main(String args[]){
		try{
		System.out.print(new SimpleDateFormat("yyyy/MM/dd hh:mm").parse("2006/01/23 12:10"));
	} catch(Exception e) {
		e.printStackTrace();
	}
	}
}
