/**
 * Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.impl.dataflow.persistent;

import java.util.List;

import javax.jcr.RepositoryException;

import org.exoplatform.services.jcr.impl.core.SessionImpl;
import org.exoplatform.services.jcr.impl.dataflow.ItemDataChangesLog;
import org.exoplatform.services.jcr.impl.dataflow.ItemsPersistenceListener;

/**
 * Created by The eXo Platform SARL        .<br/>
 * responsible for data replication (both storage and cache) in a case of cluster environment 
 * it is optional component, its presense is dependent on whether cluster environment is configured 
 * @author Gennady Azarenkov
 * @version $Id: $
 */

public class WorkspaceDataReplicator implements ItemsPersistenceListener {
  
  private final CacheableWorkspaceDataManager dataManager; 
  
  public WorkspaceDataReplicator(CacheableWorkspaceDataManager dataManager) {
    this.dataManager = dataManager;
    dataManager.addItemPersistenceListener(this);
  }

  public void onBatchSaveItems(List itemStates, SessionImpl session) {
  }

  public void onSaveItems(List itemStates, SessionImpl session) {
    // broadcast messages
  }
  
  public void receive(ItemDataChangesLog changesLog) throws RepositoryException {
    dataManager.save(changesLog);
  }
  
}
