/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.jcr.ext.metadata;

import java.io.FileInputStream;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import javax.jcr.Node;

import org.exoplatform.container.xml.InitParams;
import org.exoplatform.container.xml.ObjectParameter;
import org.exoplatform.services.jcr.ext.BaseStandaloneTest;
import org.exoplatform.services.jcr.impl.ext.action.ActionConfiguration;
import org.exoplatform.services.jcr.impl.ext.action.AddActionsPlugin;
import org.exoplatform.services.jcr.impl.ext.action.SessionActionCatalog;
import org.exoplatform.services.jcr.impl.ext.action.AddActionsPlugin.ActionsConfig;

public class MetaDataActionTest extends BaseStandaloneTest {


  public void testAddContent() throws Exception {
    ActionConfiguration ac = new ActionConfiguration(
        "org.exoplatform.services.jcr.ext.metadata.AddMetadataAction", 
        "addProperty,changeProperty", "/test,/exo:test1", true, 
        null, "nt:resource", null);
    List actionsList = new ArrayList();
    ActionsConfig actions = new ActionsConfig();
    actions.setActions(actionsList);
    actionsList.add(ac);
    InitParams params = new InitParams();
    ObjectParameter op = new ObjectParameter();
    op.setObject(actions);
    op.setName("actions");
    params.addParameter(op);
    
    AddActionsPlugin aap = new AddActionsPlugin(params);
    SessionActionCatalog catalog = (SessionActionCatalog)
      container.getComponentInstanceOfType(SessionActionCatalog.class);
    catalog.clear();
    catalog.addPlugin(aap);
    
    InputStream is = new FileInputStream("src/resources/test/test_index.xls");
    
    Node contentNode = root.addNode("test", "nt:resource");
    contentNode.setProperty("jcr:encoding", "UTF-8");
    contentNode.setProperty("jcr:data", is);
    contentNode.setProperty("jcr:mimeType", "application/excel");
    contentNode.setProperty("jcr:lastModified", Calendar.getInstance());
    root.save();
    
    Node testNode = repository.getSystemSession().getRootNode().getNode("test");
    assertTrue(testNode.hasProperty("dc:creator"));
    assertTrue(testNode.hasProperty("dc:date"));
    assertTrue(testNode.hasProperty("dc:contributor"));
    
  }
  
}
