/***************************************************************************
 * Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.jcr.util.io;

import java.io.FileInputStream;
import java.io.FileNotFoundException;

/**
 * Created by The eXo Platform SARL
 * Author : Peter Nedonosko
 *          peter.nedonosko@exoplatform.com.ua
 * 25.10.2006
 * 
 * @author <a href="mailto:peter.nedonosko@exoplatform.com.ua">Peter Nedonosko</a>
 * @version $Id: SharedFileInputStream.java 9852 2006-10-28 11:34:29Z peterit $
 */
public class SharedFileInputStream extends FileInputStream {

  private final SharedFile sfile; 

  public SharedFileInputStream(SharedFile sfile) throws FileNotFoundException {
    super(sfile);
    this.sfile = sfile;
  }
  
  protected SharedFile getSharedFile() {
    return sfile;
  }
  
  public LazySharedFileInputStream asLazy() {
    return new LazySharedFileInputStream(getSharedFile());
  }
}
