/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.impl.core;

import org.exoplatform.services.jcr.datamodel.InternalQName;

/**
 * Created by The eXo Platform SARL        .
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: JCRName.java 9155 2006-09-27 09:02:21Z peterit $
 */

public class JCRName {
	
	protected final String prefix;
	protected final String name;
	protected final String namespace;

	JCRName(String namespace, String name, String prefix) {
		this.name = name;
		this.namespace = namespace;
		this.prefix = prefix;
	}

	
	/**
	 * @return Returns the internalName.
	 */
	public String getNamespace() {
		return namespace;
	}
	/**
	 * @return Returns the name.
	 */
	public String getName() {
		return name;
	}
	/**
	 * @return Returns the namespace.
	 */
	public String getPrefix() {
		return prefix;
	}

	
	/**
	 * @return Returns the internalName.
	 */
	public InternalQName getInternalName() {
		return new InternalQName(namespace, name);
	}
	
	
	/**
	 * Stringify this name
	 * @param showIndex if index should be included to the string
	 * @return
	 */
	public String getAsString() {
    String prefixStr = prefix.length() == 0 ? "" : getPrefix() + ":";
	  return prefixStr + getName();
	}

	public boolean equals(Object obj) {
    	if (this == obj) {
    	    return true;
    	}
    	if (obj instanceof JCRName) {
    	    JCRName other = (JCRName) obj;
          // [PN] 20.09.06
    	    //return this.getAsString().equals(other.getAsString());
          return this.getInternalName().equals(other.getInternalName());
    	}
    	return false;
    }

}

