/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  The ASF licenses this file to You
 * under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.exoplatform.services.jcr.impl.core.query.sql;

import org.exoplatform.services.jcr.impl.core.query.QueryTreeBuilder;
import org.exoplatform.services.jcr.impl.core.query.QueryRootNode;
import org.exoplatform.services.jcr.impl.core.LocationFactory;


import javax.jcr.query.InvalidQueryException;
import javax.jcr.query.Query;

/**
 * Implements the SQL query tree builder.
 */
public class QueryBuilder implements QueryTreeBuilder {

    /**
     * @inheritDoc
     */
    public QueryRootNode createQueryTree(String statement,
                                         LocationFactory locationFactory)
            throws InvalidQueryException {
        return JCRSQLQueryBuilder.createQuery(statement, locationFactory);
    }

    /**
     * @inheritDoc
     */
    public boolean canHandle(String language) {
        return Query.SQL.equals(language);
    }

    /**
     * @inheritDoc
     */
    public String toString(QueryRootNode root, LocationFactory locationFactory)
            throws InvalidQueryException {
        return JCRSQLQueryBuilder.toString(root, locationFactory);
    }
}
