/**
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.impl.dataflow;

import java.util.ArrayList;
import java.util.List;

import org.exoplatform.services.jcr.dataflow.ItemDataChangesLog;
import org.exoplatform.services.jcr.dataflow.ItemState;

/**
 * Created by The eXo Platform SARL        .
 * @author <a href="mailto:gennady.azarenkov@exoplatform.com">Gennady Azarenkov</a>
 * @version $Id: MutableItemDataChangesLog.java 5988 2006-06-05 11:24:52Z geaz $
 */

public class MutableItemDataChangesLog extends ItemDataChangesLog {

//  /**
//   * @deprecated
//   */
//  public MutableItemDataChangesLog(SessionImpl session) {
//    super(new ArrayList <ItemState> (), session);
//  }

  public MutableItemDataChangesLog() {
    super(new ArrayList <ItemState> (), (String)null);
  }

  public MutableItemDataChangesLog(String sessionId) {
    super(new ArrayList <ItemState> (), sessionId);
  }


  /**
   * Add changes to the log
   * @param restoredChanges
   */
  public MutableItemDataChangesLog add(ItemState change) {
    items.add(change);
    return this;
  }

  public MutableItemDataChangesLog addAll(List <ItemState> changes) {
    items.addAll(changes);
    return this;
  }

  public void clear() {
    items.clear();
  }

}
