/***************************************************************************
 * Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.jcr.util.io;

import java.io.File;

/**
 * Created by The eXo Platform SARL
 * Author : Peter Nedonosko
 *          peter.nedonosko@exoplatform.com.ua
 * 02.11.2006
 * @author <a href="mailto:peter.nedonosko@exoplatform.com.ua">Peter Nedonosko</a>
 * @version $Id: FSUtil.java 12843 2007-02-16 09:11:18Z peterit $
 */
public class FSUtil {

  public static String getTempDir() {
    try {
      final File userTempDir = File.createTempFile("exo_jcr_temp_file_", "probe");
      final String tempDir = userTempDir.getParentFile().getAbsolutePath();
      userTempDir.delete();
      return tempDir;
    } catch(Throwable e) {
      String tempDir = System.getProperty("java.io.tmpdir");
      if (tempDir == null || (tempDir != null && tempDir.length()<=0)) {
        tempDir = new File(".").getAbsolutePath() + File.separator + "temp";
      }
      return tempDir;
    }
  }
  
}
