/***************************************************************************
 * Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.jcr.util.io;

import java.io.File;

import org.apache.commons.logging.Log;
import org.exoplatform.services.log.ExoLogger;

/**
 * Created by The eXo Platform SARL
 * Author : Peter Nedonosko
 *          peter.nedonosko@exoplatform.com.ua
 * 05.10.2006
 * 
 * @author <a href="mailto:peter.nedonosko@exoplatform.com.ua">Peter Nedonosko</a>
 * @version $Id: TempFile.java 12843 2007-02-16 09:11:18Z peterit $
 */
public class TempFile extends SharedFile {

  private static Log log = ExoLogger.getLogger("jcr.TempFile");
  
  private boolean wasRenamed = false;
  
  public TempFile(String fileName) {
    super(fileName);
    this.FILE_SUBJECT_NAME = "temporary";
  }

  @Override
  public boolean renameTo(File dest) {
    //long ss = length();
    wasRenamed = super.renameTo(dest);
    //log.info(">>>>>> renameTo " + getAbsolutePath() + " --> " + dest.getAbsolutePath() + " " + wasRenamed + " " + ss + " --> " + dest.length());
    return wasRenamed;
  }
  
  @Override
  public boolean delete() {
    if (!wasRenamed) {
      return super.delete();
    }

    return true;
  }

  @Override
  protected void finalize() throws Throwable {
    try {
      delete();
    } finally {
      super.finalize();
    }
  }  
}
