/**
* Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
* Please look at license.txt in info directory for more license detail.   *
*/

package org.exoplatform.services.webdav.commands.deltav;

import java.util.ArrayList;

import javax.jcr.RepositoryException;

import org.exoplatform.services.webdav.commands.WebDavCommand;
import org.exoplatform.services.webdav.request.documents.RequestDocument;
import org.exoplatform.services.webdav.request.documents.VersionTreeDoc;
import org.exoplatform.services.webdav.resource.DavResource;
import org.exoplatform.services.webdav.resource.DeltaVResource;
import org.exoplatform.services.webdav.response.MultiStatus;
import org.exoplatform.services.webdav.response.Response;

/**
 * Created by The eXo Platform SARL
 * Author : Vitaly Guly <gavrik-vetal@ukr.net/mail.ru>
 * @version $Id: ReportCommand.java 12304 2007-01-25 10:23:57Z gavrikvetal $
 */

public class ReportCommand extends WebDavCommand {

  protected boolean process() throws RepositoryException {    
    RequestDocument requestDoc = davRequest().getDocumentFromRequest();
    
    if (!(requestDoc instanceof VersionTreeDoc)) {
      davResponse().answerPreconditionFailed();
      return false;
    }
    
    DavResource resource = getResourceFactory().getSrcResource(false);
    
    if (!(resource instanceof DeltaVResource)) {
      davResponse().answerForbidden();
      return false;
    }
    
    int depth = davRequest().getDepth();
    
    ArrayList<Response> responses = ((DeltaVResource)resource).getVersionResponces((VersionTreeDoc)requestDoc, depth);
    
    MultiStatus multistatus = new MultiStatus(responses);
    
    davResponse().setMultistatus(multistatus);
    
    return true;
  }
  
}
