/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: Component.java 10464 2006-11-21 18:55:33Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.applet.deploy;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * @version $Rev: 10464 $ $Date: 2006-11-22 01:55:33 +0700 (Wed, 22 Nov 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
public class Component implements Serializable {

    public static final String APPLET_SCOPE = "applet";
    public static final String SHARED_SCOPE = "shared";

	private static final long serialVersionUID = 1L;

	private String groupId;
	private String artifactId;
	private String version;
	private String classifier;
	private String scope;
	private String type;

	private List pluginClassNames = new ArrayList();

    /**
     * 
     *
     */
    public Component() {
        super();
    }

    /**
     * 
     * @param groupId
     * @param artifactId
     * @param version
     * @param type
     * @param classifier
     * @param scope
     */
    public Component(String groupId, String artifactId, String version,
    		String type, String classifier, String scope) {
	    super();

	    this.groupId = groupId;
	    this.artifactId = artifactId;
	    this.version = version;
	    this.type = type;
	    this.classifier = classifier;
	    this.scope = scope;
    }

    public String getId() {
    	return getGroupId() + '.' + getArtifactId();
    }

	/**
     * @return the artifactId
     */
    public String getArtifactId() {
    	return artifactId;
    }

	/**
     * @return the classifier
     */
    public String getClassifier() {
    	return classifier;
    }

	/**
     * @return the groupId
     */
    public String getGroupId() {
    	return groupId;
    }

	/**
     * @return the scope
     */
    public String getScope() {
    	return scope;
    }

	/**
     * @return the version
     */
    public String getVersion() {
    	return version;
    }

	/**
     * @return the type
     */
    public String getType() {
	    return type;
    }

    /**
     * @return the pluginClassNames
     */
    public List getPluginClassNames() {
    	return pluginClassNames;
    }

    /**
     * 
     * @param artifactId
     */
	public void setArtifactId(String artifactId) {
        this.artifactId = artifactId;
    }

    /**
     * 
     * @param classifier
     */
    public void setClassifier(String classifier) {
        this.classifier = classifier;
    }

    /**
     * @param groupId
     */
    public void setGroupId(String groupId) {
        this.groupId = groupId;
    }

    /**
     * @param pluginClassNames
     */
    public void setPluginClassNames(List pluginClassNames) {
        this.pluginClassNames = pluginClassNames;
    }

    /**
     * @param scope
     */
    public void setScope(String scope) {
        this.scope = scope;
    }

    /**
     * @param type
     */
    public void setType(String type) {
        this.type = type;
    }

    /**
     * @param version
     */
    public void setVersion(String version) {
        this.version = version;
    }

    /**
     * @param pluginClassNames the pluginClassNames to set
     */
    public void addPluginClassName(String pluginClassName) {
    	pluginClassNames.add(pluginClassName);
    }

}
