/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: LauncherConfiguration.java 10464 2006-11-21 18:55:33Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.applet.deploy;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * @version $Rev: 10464 $ $Date: 2006-11-22 01:55:33 +0700 (Wed, 22 Nov 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
public class LauncherConfiguration implements Serializable {

    private static final long serialVersionUID = 1L;

    private String appletClassName;
    private String appletInfo;
    private String appletName;
    private String appletDependencyId;
    private String installBaseDirName;
    private String repoBaseUrl;
    
    /**
     * List<Component>
     */
    private List components = new ArrayList();

    public LauncherConfiguration() {
	    super();
    }

	/**
     * @return the appletClassName
     */
    public String getAppletClassName() {
    	return appletClassName;
    }

	/**
     * @param appletClassName the appletClassName to set
     */
    public void setAppletClassName(String appletClassName) {
    	this.appletClassName = appletClassName;
    }

	/**
     * @return the appletComponentId
     */
    public String getAppletDependencyId() {
    	return appletDependencyId;
    }

	/**
     * @param appletComponentId the appletComponentId to set
     */
    public void setAppletDependencyId(String appletComponentId) {
    	this.appletDependencyId = appletComponentId;
    }

	/**
     * @return the appletInfo
     */
    public String getAppletInfo() {
    	return appletInfo;
    }

	/**
     * @param appletInfo the appletInfo to set
     */
    public void setAppletInfo(String appletInfo) {
    	this.appletInfo = appletInfo;
    }

	/**
     * @return the appletName
     */
    public String getAppletName() {
    	return appletName;
    }

	/**
     * @param appletName the appletName to set
     */
    public void setAppletName(String appletName) {
    	this.appletName = appletName;
    }

	/**
     * @return the baseDirectoryName
     */
    public String getInstallBaseDirName() {
    	return installBaseDirName;
    }

	/**
     * @param baseDirectoryName the baseDirectoryName to set
     */
    public void setInstallBaseDirName(String baseDirectoryName) {
    	this.installBaseDirName = baseDirectoryName;
    }

	/**
     * @return the components
     */
    public List getComponents() {
    	return components;
    }

	/**
     * @param dependencies the components to set
     */
    public void setComponents(List dependencies) {
    	this.components = dependencies;
    }

    /**
     * @return the urlContext
     */
    public String getRepoBaseUrl() {
	    return repoBaseUrl;
    }

    /**
     * @param baseUrl the urlContext to set
     */
    public void setRepoBaseUrl(String baseUrl) {
	    this.repoBaseUrl = baseUrl;
    }
}
