/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: Base64Serializer.java 8877 2006-09-14 13:51:24Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.applet.util;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

/**
 * @version $Rev: 8877 $ $Date: 2006-09-14 20:51:24 +0700 (Thu, 14 Sep 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
public class Base64Serializer {

	public static Object deserialize(byte[] encodedObject) throws IOException, ClassNotFoundException {

		ByteArrayInputStream in = null;

		{
			Base64Encoder encoder = new Base64Encoder();

			ByteArrayOutputStream decoded = new ByteArrayOutputStream();
			encoder.decode(encodedObject, 0, encodedObject.length, decoded);
	
			in = new ByteArrayInputStream(decoded.toByteArray());
		}

		ObjectInputStream objectInput = new ObjectInputStream(in);

		return objectInput.readObject();
	}

	public static byte[] serialize(Serializable object) throws IOException {

		ByteArrayOutputStream decoded = new ByteArrayOutputStream();

		{
			Base64Encoder encoder = new Base64Encoder();

			ByteArrayOutputStream out = new ByteArrayOutputStream();
			ObjectOutputStream objectOutput = new ObjectOutputStream(out);
	
			objectOutput.writeObject(object);
			encoder.encode(out.toByteArray(), 0, out.size(), decoded);
		}

		return decoded.toByteArray();
	}

}
