/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: InstallDispatcher.java 8877 2006-09-14 13:51:24Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.applet.install.event;

import java.util.Iterator;
import java.util.List;
import java.util.Vector;

/**
 * @version $Rev: 8877 $ $Date: 2006-09-14 20:51:24 +0700 (Thu, 14 Sep 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
public class InstallDispatcher {

	private class Firer implements Runnable {

		private InstallListener target;
		private InstallEvent event;

        public Firer(InstallListener target, InstallEvent event) {
	        super();
	        this.target = target;
	        this.event = event;
        }

		public Thread createThread() {
			return new Thread(this, "InstallationEventDispatcher.Firer");
		}

		public void run() {
			target.onAction(event);
		}
	}

	private List listeners;

    public InstallDispatcher() {
	    super();
	    listeners = new Vector();
    }

    public void add(InstallListener l) {
    	listeners.add(l);
    }

    public void fire(InstallEvent e) {

    	Iterator it = listeners.iterator();

    	while (it.hasNext()) {

    		InstallListener target = (InstallListener) it.next();
    		Firer f = new Firer(target, e);

    		Thread t = f.createThread();
    		t.start();
    	}
    }
}
