/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: ParameterConfiguration.java 10579 2006-11-24 03:18:07Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.services.appletconfig.impl;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

/**
 * @version $Rev: 10579 $ $Date: 2006-11-24 10:18:07 +0700 (Fri, 24 Nov 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
public class ParameterConfiguration {

    private String width;
    private String height;

    private Set configSet = new HashSet();
    private Map params;

    /**
     * @param params
     */
    public ParameterConfiguration() {
        super();
    }

    /**
     * @return the height
     */
    public String getHeight() {
        return height;
    }

    /**
     * @param height the height to set
     */
    public void setHeight(String height) {
        this.height = height;
    }

    /**
     * @return the width
     */
    public String getWidth() {
        return width;
    }

    /**
     * @param width the width to set
     */
    public void setWidth(String width) {
        this.width = width;
    }

    public Map getParams() {
        if (params == null) {
            params = new HashMap();

            Iterator it = configSet.iterator();
            while (it.hasNext()) {
                String param = (String) it.next();
                int separatorPos = param.indexOf('=');
                if (separatorPos > 0) {
                    String[] a = param.split("=", 2);
                    String key = a[0];
                    String value = (a.length == 2 ? a[1] : "");
                    addParam(key, value);
                }
            }
        }
        return this.params;
    }

    /**
     * @return the params
     */
    public Set getConfigSet() {
        return configSet;
    }

    /**
     * @param configs the params to set
     */
    public void setConfigSet(Set cfg) {
        this.configSet = cfg;
        this.params = null;
    }

    /**
     * @param key
     * @param value
     */
    private void addParam(String key, String value) {
        this.params.put(key, value);
    }

}
