/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: EmbedTagAppletEmbedding.java 10468 2006-11-22 00:20:32Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.services.appletconfig.impl.embed;

import java.util.Iterator;
import java.util.Map;

import org.exoplatform.services.appletconfig.impl.ParameterConfiguration;

/**
 * @version $Rev: 10468 $ $Date: 2006-11-22 07:20:32 +0700 (Wed, 22 Nov 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
class EmbedTagAppletEmbedding implements EmbeddingStrategy {

    /**
     * 
     */
    public EmbedTagAppletEmbedding() {
        super();
    }

    /* (non-Javadoc)
     * @see org.exoplatform.services.appletconfig.impl.EmbeddingStrategy#render(java.lang.String, org.exoplatform.services.appletconfig.impl.ParameterConfiguration, java.util.Map)
     */
    public String render(String objectId, ParameterConfiguration pc,
            Map<String, String> parameters) {

        StringBuffer html = new StringBuffer();

        html.append(generateStartApplet(objectId, pc, parameters));
        html.append(generateEndApplet());

        return html.toString();
    }

    protected static String generateStartApplet(String objectId,
            ParameterConfiguration pc, Map<String, String> params) {

        return "<embed id=\"" + objectId + "\" width=\"" + pc.getWidth()
                + "\" height=\"" + pc.getHeight() + "\"" +
                generateParameters(params) + ">";
    }

    private static String generateParameters(Map<String, String> params) {

        StringBuffer sb = new StringBuffer();

        Iterator<String> it = params.keySet().iterator();
        while (it.hasNext()) {
            String name = it.next();
            String value = params.get(name);

            sb.append(" " + name + "=\"" + value + "\"");
        }

        return sb.toString();
    }

    protected static String generateEndApplet() {
        return "</embed>";
    }

}
