/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: MixedAppletEmbedding.java 10468 2006-11-22 00:20:32Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.services.appletconfig.impl.embed;

import java.util.Map;

import org.exoplatform.services.appletconfig.impl.ParameterConfiguration;

/**
 * @version $Rev: 10468 $ $Date: 2006-11-22 07:20:32 +0700 (Wed, 22 Nov 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
class MixedAppletEmbedding implements EmbeddingStrategy {

    /**
     * 
     */
    public MixedAppletEmbedding() {
        super();
    }

    /* (non-Javadoc)
     * @see org.exoplatform.services.appletconfig.impl.EmbeddingStrategy#render(java.lang.String, org.exoplatform.services.appletconfig.impl.ParameterConfiguration, java.util.Map)
     */
    public String render(String objectId, ParameterConfiguration pc,
            Map<String, String> parameters) {

        StringBuffer html = new StringBuffer();

        // start with <object>
        html.append(ObjectTagAppletEmbedding.generateStartApplet(objectId, pc));
        html.append(ObjectTagAppletEmbedding.generateParameters(parameters));

        // add comment tag within <object> to include the <embed> tag
        html.append("<comment>");

        // produce the whole <embed> tags
        html.append(EmbedTagAppletEmbedding.generateStartApplet(objectId, pc, parameters));
        // TODO use resourceBundle instead (get localized string from properties)
        html.append("<noembed>No Java Plugin Installed</noembed>");
        html.append(EmbedTagAppletEmbedding.generateEndApplet());

        // end comment tag and <object> tags
        html.append("</comment>");
        html.append(ObjectTagAppletEmbedding.generateEndApplet());

        return html.toString();
    }

}
