/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: ObjectTagAppletEmbedding.java 10591 2006-11-24 05:07:15Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.services.appletconfig.impl.embed;

import java.util.Iterator;
import java.util.Map;

import org.exoplatform.services.appletconfig.impl.ParameterConfiguration;

/**
 * @version $Rev: 10591 $ $Date: 2006-11-24 12:07:15 +0700 (Fri, 24 Nov 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
class ObjectTagAppletEmbedding implements EmbeddingStrategy {

    /**
     *
     */
    public ObjectTagAppletEmbedding() {
        super();
    }

    /*
     * (non-Javadoc)
     *
     * @see org.exoplatform.services.appletconfig.impl.EmbeddingStrategy#render(java.lang.String,
     *      org.exoplatform.services.appletconfig.impl.ParameterConfiguration,
     *      java.util.Map)
     */
    public String render(String objectId, ParameterConfiguration pc,
            Map<String, String> parameters) {

        StringBuffer html = new StringBuffer();

        html.append(generateStartApplet(objectId, pc));
        html.append(generateParameters(parameters));
        html.append(generateEndApplet());

        return html.toString();
    }

    protected static String generateStartApplet(String objectId,
            ParameterConfiguration pc) {

		// use clsid below to instruct IE-like browser to use last JRE plugin available
        return "<object id=\"" + objectId + "\" width=\"" + pc.getWidth()
                + "\" height=\"" + pc.getHeight() + "\" " +
                "classid=\"clsid:8AD9C840-044E-11D1-B3E9-00805F499D93\">";
    }

    protected static String generateParameters(Map<String, String> params) {

        StringBuffer sb = new StringBuffer();

        Iterator<String> it = params.keySet().iterator();
        while (it.hasNext()) {
            String name = it.next();
            String value = params.get(name);

            sb.append("<param name=\"" + name + "\" value=\"" + value + "\"/>");
        }

        return sb.toString();
    }

    protected static String generateEndApplet() {
        return "</object>";
    }

}
