/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.templates.groovy;

import java.io.InputStream;
import java.net.URL;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Mar 2, 2005
 * @version $Id: GroovyTemplateClasspathLoader.java 5799 2006-05-28 17:55:42Z geaz $
 */
public class GroovyTemplateClasspathLoader extends GroovyTemplateLoader {
  ClassLoader classloader_ ;
  
  public GroovyTemplateClasspathLoader() {
    
  }
  
  public GroovyTemplateClasspathLoader(ClassLoader classloader) {
    classloader_ = classloader ;
  }
  
  public boolean canLoad(String type, String template) throws Exception {
    ClassLoader cl = classloader_ ;
    if(cl == null) cl = Thread.currentThread().getContextClassLoader() ;
    URL url = cl.getResource(template) ;
    return url != null ;
  }
  
  public InputStream load(String template) throws Exception {
    ClassLoader cl = classloader_ ;
    if(cl == null) cl = Thread.currentThread().getContextClassLoader() ;
    return cl.getResourceAsStream(template) ;
  }
}
