/*******************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL All rights reserved. * Please look
 * at license.txt in info directory for more license detail. *
 ******************************************************************************/
package org.exoplatform.faces.core.renderer.html;

import java.io.IOException;
import java.util.ResourceBundle;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

import org.exoplatform.faces.core.component.UICalendarInput;

public class CalendarInputRenderer extends HtmlBasicRenderer {
	
	private String SYSDATE = "sysdate";
	  
  public void encodeBegin(FacesContext context, UIComponent component)
      throws IOException {
    UICalendarInput uiCalendar = (UICalendarInput) component;
    ResponseWriter w = context.getResponseWriter() ;
    String value = uiCalendar.getText() ;
   
    ResourceBundle res = getApplicationResourceBundle(context
            .getExternalContext());
    String fieldName = uiCalendar.getName();
   
    if (value == null) value = "" ; 
    
    w.write("<script type=\"text/javascript\" src=\"/resources/community/script/calendar/calendar.js\"></script>");
    w.write("<script type=\"text/javascript\" src=\"/resources/community/script/calendar/calendar-setup.js\"></script>");
    w.write("<script type=\"text/javascript\" src=\"/resources/community/script/calendar/lang/calendar-"+res.getLocale().getLanguage()+".js\"></script>");

    w.write("<input type=\"text\" name='"+fieldName+"' id='"+fieldName+"' value='"+(String)uiCalendar.getDecodedValue()+"'/>");
    w.write("<img id=\"trigger");
    w.write(fieldName);
    w.write("\" src=\"");
    w.write("/resources/community/images/calendar/calendar.gif\"");
    w.write(" onClick=\""+fieldName+"_calendar_onClick('"+fieldName+"_calendar');\"/>");    		
    		
    w.write("<script type=\"text/javascript\">");
    w.write("   Calendar.setup({");
    w.write("	inputField     :    \""+fieldName+"\","); 
    if(uiCalendar.isDisplayTime()){
	    w.write("	ifFormat       :    \"%d/%m/%Y %H:%M\",");
	    w.write("	showsTime      :    true,");
	    w.write("	timeFormat 	   :	24,  ");
    } else{
	    w.write("	ifFormat       :    \"%d/%m/%Y\",");
    }   
    w.write("	button         :    \"trigger"+fieldName+"\",");
    w.write("	singleClick    :    false,");
    w.write("	step           :    1,");
    w.write("	date           :    \"" + (String)uiCalendar.getDecodedValue() + "\"");
    w.write("});");
    w.write("</script>");
    
    w.write("<noscript>");
    if(uiCalendar.isDisplayTime()){
    	w.write("<label for=\""+fieldName+"\">(gg/mm/aaaa oo:mm)");
    }else{
    	w.write("<label for=\""+fieldName+"\">(gg/mm/aaaa)");
    }
    w.write("<input type=\"text\" name='"+fieldName+"' id='"+fieldName+"'/>");
    w.write("</noscript>");

  }


}