/**
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail. 
 */
package org.exoplatform.portlet.faces.component;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;
import java.util.ResourceBundle;

import javax.faces.context.FacesContext;
import javax.portlet.PortletPreferences;
import javax.portlet.PortletRequest;

import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
/**
 * Created y the eXo platform team
 * User: Benjamin Mestrallet
 * Date: 31 ao�t 2004
 */
public class UIPreferencesForm extends UISimpleForm {
  private static final String ENCODING = "pref_";
  protected ResourceBundle res;
  
  private List<Prefs> listPrefs ;

  public UIPreferencesForm(ResourceBundle res) {
    super("preferencesForm", "post", null);
    setClazz("UIPreferencesForm");
    setId("UIPreferencesForm") ;
    setRendererType("SimpleFormVelocityRenderer") ;
    this.res = res;
    FacesContext context = FacesContext.getCurrentInstance();
    PortletRequest request = (PortletRequest) context.getExternalContext().getRequest();
    PortletPreferences  prefs = request.getPreferences();
    String[] defaultValues = {""};
    listPrefs = new ArrayList<Prefs>();
    Enumeration enumer = prefs.getNames();
    while(enumer.hasMoreElements()){
      String name = String.valueOf(enumer.nextElement());
      String[] values = prefs.getValues(name, defaultValues);
      for(String ele : values){
        listPrefs.add(new Prefs(name, ele));
      }
    }
    addActionListener(UpdatePreferencesListener.class, SAVE_ACTION);
  }
  
  public List<Prefs> getListPrefs(){ return listPrefs; }
  
  static public class UpdatePreferencesListener extends ExoActionListener  {
    public UpdatePreferencesListener() {
      //addInterceptor(new CheckRoleInterceptor("admin")) ;  
    }
    public void execute(ExoActionEvent event) throws Exception {
      FacesContext facesContext = FacesContext.getCurrentInstance();
      PortletRequest request = (PortletRequest) facesContext.getExternalContext().getRequest();
      PortletPreferences prefs = request.getPreferences();
      
      Enumeration e = request.getParameterNames();
      while (e.hasMoreElements()) {
        String paramName = (String) e.nextElement();
          String name = paramName;
          String[] values =  request.getParameterValues(paramName);
          prefs.setValues(name, values);
      }
      prefs.store();
    }
  }
  static public class Prefs {
    private String name;
    private String value;
    
    public Prefs(String name, String value){
      this.name = name;
      this.value = value;
    }
    
    public String getName(){ return name; }
    
    public String getValue(){ return value ; }
    
    public void setName(String name) { this.name = name;}
    
    public void setValue(String value) { this.value = value; }
  }
}
