/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.faces.component.logic;

import java.util.List;

import org.exoplatform.portal.faces.component.UIBody;
import org.exoplatform.portal.faces.component.UIPage;
import org.exoplatform.portal.faces.component.UIPortal;
import org.exoplatform.portal.faces.component.UIPortalComponent;
import org.exoplatform.portal.faces.component.Util;

/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Mar 18, 2005
 * @version $Id$
 */
public class PortalMode {
  static public boolean changePortalViewlMode(UIPortal uiPortal) {
    uiPortal.setSelectedPage(uiPortal.getSelectedNode()) ;
    setMode(uiPortal, UIPortalComponent.COMPONENT_VIEW_MODE) ;
    return true ;
  }
  
  static public boolean changePortalEditMode(UIPortal uiPortal) throws Exception {
    if(uiPortal.hasEditPortalCapability()) {
      uiPortal.setMode(UIPortalComponent.COMPONENT_VIEW_MODE) ;
      setMode(Util.findDescendantsOfTypeInPortal(uiPortal, UIPortalComponent.class),
              UIPortalComponent.COMPONENT_EDIT_MODE) ;
      UIBody uiBody = uiPortal.findUIBody() ;
      setMode(uiBody.findDescendantsOfType(UIPortalComponent.class),
              UIPortalComponent.COMPONENT_VIEW_MODE) ;
      return true ;
    }
    return false ;
  }
  
  static public boolean changePortalEditPageMode(UIPortal uiPortal) {
    uiPortal.setMode(UIPortalComponent.COMPONENT_VIEW_MODE) ;
    setMode(Util.findDescendantsOfTypeInPortal(uiPortal, UIPortalComponent.class),
            UIPortalComponent.COMPONENT_VIEW_MODE) ;
    uiPortal.setSelectedPage(uiPortal.getSelectedNode()) ;
    UIPage uiPage = (UIPage)uiPortal.findDescendantOfType(UIPage.class);
    if(uiPage.hasComponentAdminRole()) {
      setMode(uiPage.findDescendantsOfType(UIPortalComponent.class),
              UIPortalComponent.COMPONENT_EDIT_MODE) ;
      return true ;
    } 
    setMode(uiPage.findDescendantsOfType(UIPortalComponent.class),
            UIPortalComponent.COMPONENT_VIEW_MODE) ;
    return false ;
  }
  
  static public boolean changePortalEditNavigationMode(UIPortal uiPortal) throws Exception {
    if(uiPortal.hasEditNavigationCapability()) {
      uiPortal.setMode(UIPortalComponent.COMPONENT_EDIT_MODE) ;
      setMode(uiPortal.findDescendantsOfType(UIPortalComponent.class),
              UIPortalComponent.COMPONENT_VIEW_MODE) ;
      return true ;
    }
    return false ;
  }
  
  static public void changePageMode(UIPage uiPage, int mode) {
    if(mode == UIPortalComponent.COMPONENT_EDIT_MODE &&
       uiPage.hasComponentAdminRole()) {
      setMode(uiPage, UIPortalComponent.COMPONENT_EDIT_MODE) ;
      return ;
    } 
    setMode(uiPage, UIPortalComponent.COMPONENT_VIEW_MODE) ;
  }
  
  static private void setMode(List components, int mode) {
    for(int i = 0; i < components.size(); i++) {
      UIPortalComponent component = (UIPortalComponent) components.get(i) ;
      component.setMode(mode) ;
    }
  }
  
  static private void setMode(UIPortalComponent ui, int mode) {
    ui.setMode(mode) ;
    List components = ui.findDescendantsOfType(UIPortalComponent.class) ;
    for(int i = 0; i < components.size(); i++) {
      UIPortalComponent component = (UIPortalComponent) components.get(i) ;
      component.setMode(mode) ;
    }
  }
}
