/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.faces.listener.page;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;
import org.exoplatform.portal.PortalConstants;
import org.exoplatform.portal.config.PortalConfigService;
import org.exoplatform.portal.faces.component.UIContainer;
import org.exoplatform.portal.faces.component.UIPage;
import org.exoplatform.portal.faces.component.UIPortal;
import org.exoplatform.portal.faces.component.UIPortalComponent;
import org.exoplatform.portal.faces.component.UIPortlet;
/**
 * Jun 10, 2004 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: PageActionListener.java,v 1.1 2004/09/26 02:25:47 tuan08 Exp $
 */
public class PageActionListener extends ExoActionListener {
  public void execute(ExoActionEvent event) throws Exception {
    String portalAction = event.getAction() ;
    if (PortalConstants.SAVE_PAGE_ACTION.equals(portalAction)) {
      UIPortal uiPortal = (UIPortal) event.getSource() ;
      UIPage uiPage = uiPortal.getCurrentUIPage() ;
      uiPage.buildTreeModel(null) ;
      PortalConfigService service = (PortalConfigService)PortalContainer.getInstance().
        getComponentInstanceOfType(PortalConfigService.class) ;
      service.savePage(uiPage.getPageModel(), uiPortal.getRemoteUser()) ;
      uiPage.clearComponentModified()  ;
      uiPage.setComponentDirty(false) ;
    } else  if(PortalConstants.DRAG_DROP_ACTION.equals(portalAction)) {
      UIPage uiPage = (UIPage) event.getComponent() ;
      String srcid = event.getParameter(PortalConstants.DRAG_SRC_PARAM) ;
      srcid =  srcid.substring(0, srcid.indexOf("-customizable-block")) ;
      UIPortalComponent uiSrc = 
        (UIPortalComponent)uiPage.findComponentById(srcid) ;
      String targetid = event.getParameter(PortalConstants.DROP_TARGET_PARAM);
      boolean targetIsInfoBar =  false ;
      if(targetid.endsWith("-customizable-block")) {
        targetid =  targetid.substring(0, targetid.indexOf("-customizable-block")) ;
      } else {
        targetid =  targetid.substring(0, targetid.indexOf("-info-bar")) ;
        targetIsInfoBar =  true ;
      }
      UIPortalComponent uiTarget = 
        (UIPortalComponent)uiPage.findComponentById(targetid) ;
      if(uiSrc == null ||  uiTarget == null) {
        Information iprovider = findInformationProvider(uiPage) ;
        iprovider.addMessage(new ExoFacesMessage("#{UIPage.msg.cannot-find-src-target}")) ;
        return ;
      }
      UIPortalComponent parent = (UIPortalComponent)uiSrc.getParent() ;
      parent.removeChild(uiSrc) ;
      UIContainer uiContainerTarget = null ;
      if(targetIsInfoBar || uiTarget instanceof UIPortlet) {
        Object obj = uiTarget.getParent()  ;
        if(obj instanceof UIContainer) {
          uiContainerTarget = (UIContainer) obj ;
          uiContainerTarget.insertChildBefore(uiSrc, uiTarget) ;
        } else {
          uiContainerTarget = (UIContainer) uiTarget ;
          uiContainerTarget.insertChildBefore(uiSrc, null) ;
        }
      } else {
        uiContainerTarget = (UIContainer)uiTarget  ;
        uiContainerTarget.insertChildBefore(uiSrc, null) ;
      }
    }
  }
}