/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.log.test;

import java.util.GregorianCalendar;
import java.util.List;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.portal.log.PortalActivitiesLogService;
import org.exoplatform.portal.log.PortalLogData;
import org.exoplatform.portal.log.Query;
import org.exoplatform.services.database.HibernateService;
import org.exoplatform.test.BasicTestCase;

/**
 * Thu, May 15, 2003 @   
 * @author: Tuan Nguyen
 * @version: $Id: TestSkinConfigService.java,v 1.7 2004/07/24 16:34:06 tuan08 Exp $
 * @since: 0.0
 * @email: tuan08@yahoo.com
 */
public class TestPortalActivitiesLogService  extends BasicTestCase {
  PortalActivitiesLogService service_ ;
  Query q ;
  public TestPortalActivitiesLogService(String name) {
    super(name);
  }

  public void setUp() throws Exception {
    service_ = (PortalActivitiesLogService) PortalContainer.getInstance().
                getComponentInstanceOfType(PortalActivitiesLogService.class) ;
    q = new Query() ;
    GregorianCalendar calendar = new GregorianCalendar() ;
    calendar.set(GregorianCalendar.HOUR_OF_DAY, 0) ;
    calendar.set(GregorianCalendar.MINUTE, 0) ;
    calendar.set(GregorianCalendar.SECOND, 0) ;
    calendar.set(GregorianCalendar.MILLISECOND, 0) ;
    q.setFromTimeSlot(calendar.getTime()) ;
    calendar.set(GregorianCalendar.HOUR_OF_DAY, 24) ;
    q.setToTimeSlot(calendar.getTime()) ;
    q.setComponentId("") ;
  }

  public void tearDown() throws Exception {
  }
  
  public void testSave() throws Exception {
    service_.logPortalAccess("portal1"/*PortalID*/,"admin"/*portalOwner*/,
                              20/*execTine*/, false/*error*/, false/*illegal access*/ ) ;
    service_.logPortalAccess("portal11","admin", 40, true, false ) ;   
    service_.logPortalAccess("portal111","admin", 30, true, false ) ; 
    service_.logPortalAccess("portal2","exo", 40, true, false ) ; 
    
     
    Thread.sleep(2000) ;
    List list = service_.getPortalLogDatas(q).getAll() ;
    
    assertEquals("expect  2 log data in db", 2, list.size()) ;
    PortalLogData  portal1data = (PortalLogData) list.get(0) ;
    assertEquals("expect  mydata is portal1 ", "portal1", portal1data.getPortalId()) ;
    assertEquals("expect  sum time access  of portal1 is ", 90, portal1data.getSummaryAccessTime()) ;
    assertEquals("expect  access counter of portal1 is ", 3, portal1data.getAccessCounter()) ;
    assertEquals("expect average accesss time of portal is: ", 30, portal1data.getAvgAccessTime()) ;
    assertEquals("expect portal owner of portal is:","admin",portal1data.getPortalOwner());
    assertEquals("expect error access counter of portal2 is ", 2, portal1data.getErrorCounter()) ;
    
    PortalLogData portal2data = (PortalLogData) list.get(1) ;
    assertEquals("expect portal owner of portal is:","exo",portal2data.getPortalOwner());
    System.out.println("-----------------> portal 2 data" + portal2data.hashCode()) ;
    assertEquals("expect access counter of portal2 is ", 1, portal2data.getAccessCounter()) ;
    assertEquals("expect error access counter of portal2 is ", 1, portal2data.getErrorCounter()) ;
  
    service_.logPortalAccess("portal2","exo", 40, true, false ) ;   
    service_.logPortalAccess("portal3","test", 40, true, false ) ; 
    service_.logPortalAccess("portal4","test-exo", 40, true, false ) ;  
    
    Thread.sleep(2000) ;    
    
    resetHibernateSession() ;
    
    List nextList = service_.getPortalLogDatas(q).getAll() ;
    assertEquals("expect 4 log data in db",4, nextList.size()) ;
    portal2data = (PortalLogData) nextList.get(1) ;
    assertEquals("expect portal owner of portal is:","exo",portal2data.getPortalOwner());
    System.out.println("-----------------> " + portal2data.hashCode()) ;
    assertEquals("expect  mydata is portal2 ", "portal2", portal2data.getPortalId()) ;
    assertEquals("expect average accesss time of portal is: ", 40, portal2data.getAvgAccessTime()) ;
    assertEquals("expect  sum time access  of portal1 is ", 80, portal2data.getSummaryAccessTime()) ;
    assertEquals("expect access counter of portal2 is ", 2, portal2data.getAccessCounter()) ;
    assertEquals("expect error access counter of portal2 is ", 2, portal2data.getErrorCounter()) ;

    portal2data = (PortalLogData) nextList.get(2) ;
    assertEquals("expect portal owner of portal is:","test-exo",portal2data.getPortalOwner());
    assertEquals("expect  mydata is portal4 ", "portal4", portal2data.getPortalId()) ;
    assertEquals("expect access counter of portal4 is ", 1, portal2data.getAccessCounter()) ;
    assertEquals("expect error access counter of portal4 is ", 1, portal2data.getErrorCounter()) ;
    assertEquals("expect summary access time of portal4 is ", 40, portal2data.getSummaryAccessTime()) ;
    //q.setCounter(0) ;
  
  }
 
  private  void  resetHibernateSession() {
    PortalContainer pcontainer = PortalContainer.getInstance() ;
    List<HibernateService> list = 
      pcontainer.getComponentInstancesOfType(HibernateService.class) ; 
    for(HibernateService hservice : list) hservice.closeSession() ;
    PortalContainer.setInstance(null) ;  
  }
  
 
  public void testQueryPortalLogDatas() throws Exception {    
    
    List l = service_.getPortalLogChartDatas(q) ;  
    
    Object[] row0 = (Object[])l.get(0);
    assertEquals("expect  portal owner is ", "admin", /*owner*/row0[0].toString()) ;
    assertEquals("expect  access counter is ", 3, /*accessCounter*/Long.parseLong(row0[1].toString())) ;
    assertEquals("expect  error counter is ", 2, /*errorCounter*/Long.parseLong(row0[2].toString())) ;
    assertEquals("expect  sum tim is ", 90, /*sumTime*/Long.parseLong(row0[3].toString())) ;
    
    Object[] row1 = (Object[])l.get(1);
    assertEquals("expect  portal owner is ", "exo", /*owner*/row1[0].toString()) ;
    assertEquals("expect  access counter is ",2, /*accessCounter*/Long.parseLong(row1[1].toString())) ;
    assertEquals("expect  error counter is ", 2, /*errorCounter*/Long.parseLong(row1[2].toString())) ;
    assertEquals("expect  sum tim is ", 80, /*sumTime*/Long.parseLong(row1[3].toString())) ;
       
    Object[] row2 = (Object[])l.get(2);

    assertEquals("expect  portal owner is ", "test-exo",/*owner*/row2[0].toString()) ;
    assertEquals("expect  access counter is ",1, /*accessCounter*/Long.parseLong(row2[1].toString())) ;
    assertEquals("expect  error counter is ", 1, /*errorCounter*/Long.parseLong(row2[2].toString())) ;
    assertEquals("expect  sum tim is ", 40, /*sumTime*/Long.parseLong(row2[3].toString())) ;
  }
}