/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.jmx.component;


import java.util.Collection;

import javax.management.MBeanServer;
import javax.management.ObjectName;

import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portlets.jmx.component.model.JMXServer;
import org.exoplatform.portlets.jmx.component.model.MBeanCategory;
import org.exoplatform.portlets.jmx.component.model.MBeanDescription;

/**
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIListMBean.java,v 1.2 2004/08/01 04:18:27 tuan08 Exp $
 */
public class UIListMBean extends UIExoCommand  {
  private static Parameter[] VIEW_PARAMS = {new Parameter(ACTION , "view") } ;
  
	private JMXServer server_ ;
  private MBeanCategory mdomain_;
  
	public UIListMBean() {
		setId("UIListMbean") ;
    setRendererType("VelocityRenderer");
    addActionListener(SelectMBeanActionListener.class, "view") ;
	}
  
  public void setData(JMXServer server, MBeanCategory mdomain) {
  	server_ = server ;
    mdomain_ = mdomain ;    
  }
  
  public Parameter[] getViewParams() { return VIEW_PARAMS ; }
  
  public Collection getMBeanDescriptions() { return mdomain_.getMBeanDescriptions(); }
  
  static public class SelectMBeanActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UIListMBean uiList = (UIListMBean)event.getComponent() ;
      String mbean = event.getParameter(OBJECTID) ;
      MBeanDescription md = uiList.mdomain_.findMBeanDescription(mbean) ;
      UIDetail uiDetail = (UIDetail) uiList.getAncestorOfType(UIDetail.class) ;
      uiDetail.setViewMBean(uiList.server_, md) ;
    } 
  }
} 