/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.jmx.component.model;

import javax.management.ObjectName;

/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Oct 26, 2005
 */
public class MBeanDescription {
  private String id_ ;
  private String label_ ;
  private ObjectName oname_ ;
  
  public  MBeanDescription (ObjectName name) {
    oname_ = name ;
    id_ = new String(Integer.toString(name.hashCode())) ;
    label_ = name.getKeyProperty("type") ;
    if(label_ == null) {
      label_ = "mbean" ;
    } else {
      int idx = label_.lastIndexOf('.') ;
      if(idx > 0) label_ = label_.substring(idx + 1 , label_.length()) ; 
    }
  }

  public String getId() { return id_ ;}
  public String getLabel() { return label_ ; }
  public ObjectName getObjectName() { return oname_ ; }
}
