/**
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail. 
 */
package org.exoplatform.portlets.security.component;
import java.util.List;
import org.exoplatform.commons.utils.PageList;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.UIPageListIterator;
import org.exoplatform.faces.core.component.model.PageListDataHandler;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.database.DBObjectPageList;
import org.exoplatform.services.database.HibernateService;
import org.exoplatform.services.database.ObjectQuery;
import org.exoplatform.services.ticket.TicketService;
import org.exoplatform.services.ticket.impl.TicketImpl;

/**
 * Created y the eXo platform team
 * User: chungnv
 * Date: 24 jan 2006
 */
public class UITicketMonitor  extends UIExoCommand {
  
  private UIPageListIterator uiPageIterator_ ;
  private HibernateService hservice_ ;
  private List listPage;
  protected TicketService service_;
  
  static Parameter[] EDIT = { new Parameter(ACTION , "edit") } ;
  static Parameter[] DELETE = { new Parameter(ACTION , "delete") } ;
  
  public UITicketMonitor() throws Exception {
    setId("UITicketMonitor") ;
    setRendererType("VelocityRenderer");
    PortalContainer pcontainer = PortalContainer.getInstance() ;
    service_ = (TicketService)pcontainer.getComponentInstanceOfType(TicketService.class) ;
    hservice_ = (HibernateService)pcontainer.getComponentInstanceOfType(HibernateService.class) ;
    uiPageIterator_ = new UIPageListIterator(new PageListDataHandler()) ;
    getChildren().add(uiPageIterator_);
    getChildren().add(new UITicketFilter());  
    //getChildren().add(new UITicketUpdate());
    addActionListener(TicketUpdateListener.class,"edit" );
    addActionListener(TicketDeleteListener.class,"delete");
    update(null) ;
  }
  
  public List getCurrentPageData() throws Exception {    
    return uiPageIterator_.getPageListDataHandler().getDatas() ;  
  }
  
  public Parameter[] getEditMonitorParams() { return EDIT ; };
  public Parameter[] getDeleteMonitorParams() { return DELETE ; };
  
  public void update(ObjectQuery oq) throws Exception{
    if(oq == null){
      PageList pageList ;
      ObjectQuery oqDefault = new ObjectQuery(TicketImpl.class);
      pageList = new DBObjectPageList(hservice_, oqDefault);
      listPage=pageList.getAll();
      uiPageIterator_.getPageListDataHandler().setDatas(listPage) ;
    }else{
      PageList pageList = new DBObjectPageList(hservice_, oq);
      listPage=pageList.getAll();
      uiPageIterator_.getPageListDataHandler().setDatas(listPage) ;
    }
  }
  static public class TicketUpdateListener extends ExoActionListener{
    public void execute(ExoActionEvent event) throws Exception {
      UITicketMonitor ticketMonitor = (UITicketMonitor) event.getComponent();
      String ticketId = event.getParameter(OBJECTID);
      UITicketUpdate ticketUpdate = (UITicketUpdate) ticketMonitor.getSibling(UITicketUpdate.class);
      ticketUpdate.setDefaultValues(ticketId);
      ticketMonitor.setRenderedSibling(UITicketUpdate.class);
    }
    
  }
  static public class TicketDeleteListener extends ExoActionListener{
    private TicketImpl ticketImpl;
    public void execute(ExoActionEvent event) throws Exception {
      UITicketMonitor ticketMonitor = (UITicketMonitor) event.getSource();
      String ticketId = event.getParameter(OBJECTID);
      ticketImpl = (TicketImpl)ticketMonitor.service_.getTicket(ticketId);
      ticketMonitor.hservice_.remove(ticketImpl);
      ticketMonitor.update(null);
    }
    
  }
}