package org.exoplatform.portlets.user.component;

import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
/**
 * Sat, Jan 010, 2006 @ 11:16 
 * @author: Nguyen Quang Hung
 * @email:   nguyenkequanghung@yahoo.com
 * @version: $Id: UIPersonalInfoForm.java,v 1.14 2006/01/10 13:07:02 nqhung Exp $
 */
public class UIBusinessInfoForm extends UISimpleForm {
  final static public String[] BUSINESS_INFO_KEYS = { 
                                          "business_postal_name", "business_postal_city", 
                                          "business_postal_stateprov", "business_postal_postalcode",
                                          "business_postal_country", "business_mobile_number",
                                          "business_telephone_number", "business_online_email",
                                          "business_online_uri"
                                          } ;
  
  public UIBusinessInfoForm() throws Exception {
    super("UIBusinessInfoForm", "post", null);
    setRendererType("SimpleFormVelocityRenderer") ;
    setId("UIBusinessInfoForm") ;
    add(new UIStringInput("business_postal_name", "")) ;
    add(new UIStringInput("business_postal_city", "")) ;
    add(new UIStringInput("business_postal_stateprov", "")) ;
    add(new UIStringInput("business_postal_postalcode", "")) ;
    add(new UIStringInput("business_postal_country", "")) ;
    add(new UIStringInput("business_mobile_number", "")) ;
    add(new UIStringInput("business_telephone_number", "")) ;
    add(new UIStringInput("business_online_email", "")) ;
    add(new UIStringInput("business_online_uri", "")) ;    
  }
  
  public void updateBusinessInfo(int index, String fieldValue) {
    getUIInput(BUSINESS_INFO_KEYS[index]).setValue(fieldValue) ;
  }
  
  public String getBusinessFieldInput(int index){
    return getUIInput(BUSINESS_INFO_KEYS[index]).getValue() ;
  }
}