/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.user.component;

import java.util.Date;
import java.util.GregorianCalendar;

import org.exoplatform.faces.core.component.UIDateInput;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.organization.Query;
/**
 * Sat, Jan 03, 2004 @ 11:16 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UISearchUserForm.java,v 1.6 2004/10/22 14:23:30 tuan08 Exp $
 */
public class UISearchUserForm extends UISimpleForm {

  public static final String SEARCH_USER = "searchUser";
  private static String USERNAME = "userName", FIRSTNAME = "firstName",
                        LASTNAME = "lastName", EMAIL = "email", 
                        FROMDATE = "fromDate", TODATE = "toDate";
                          
  public UISearchUserForm() {
  super("searchForm", "post", null) ;
  setId("UISearchUserForm");
  setClazz("UIAdvancedSearch");
  setRendererType("SimpleFormVelocityRenderer") ;
  add(new UIStringInput(USERNAME, "")) ;
  add(new UIStringInput(FIRSTNAME, "")) ;
  add(new UIStringInput(LASTNAME, "")) ;
  add(new UIStringInput(EMAIL, "")) ;
  add(new UIDateInput("fromDate", new GregorianCalendar(2004, 0, 1).getTime())) ;
  add(new UIDateInput("toDate", new Date())) ;
  addActionListener(SearchUserActionListener.class, SEARCH_USER) ;  
  addActionListener(CancelActionListener.class, CANCEL_ACTION );
  }
  
  public String getSearchAction() {  return SEARCH_USER ; } ;
  
  static public class SearchUserActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UISearchUserForm uiForm = (UISearchUserForm) event.getComponent() ;
      UIListUser uiListUser = (UIListUser) uiForm.getSibling(UIListUser.class) ;
      Query query = new Query() ;
      query.setUserName(uiForm.getUIStringInput(USERNAME).getValue()) ;
      query.setFirstName(uiForm.getUIStringInput(FIRSTNAME).getValue()) ;
      query.setLastName(uiForm.getUIStringInput(LASTNAME).getValue()) ;
      query.setEmail(uiForm.getUIStringInput(EMAIL).getValue()) ;
      query.setFromLoginDate((Date) uiForm.getUIDateInput(FROMDATE).getDecodedValue()) ;
      query.setToLoginDate((Date) uiForm.getUIDateInput(TODATE).getDecodedValue()) ;
    	uiListUser.search(query) ;
      uiForm.setRenderedSibling(UIListUser.class) ;
    }
  }

  static public class CancelActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UISearchUserForm uiForm = (UISearchUserForm) event.getComponent() ;
      uiForm.getUIStringInput(USERNAME).setValue("") ;
      uiForm.getUIStringInput(FIRSTNAME).setValue("") ;
      uiForm.getUIStringInput(LASTNAME).setValue("") ;
      uiForm.getUIStringInput(EMAIL).setValue("") ;
      uiForm.setRenderedSibling(UIListUser.class) ;
    }
  }
}