package javax.portlet;


public class UnavailableException extends PortletException {

  private boolean permanent;
  private int seconds;

  public UnavailableException(String text) {
    super(text);
    permanent = true;
  }

  public UnavailableException(String text, int seconds) {
    super(text);
    if (seconds <= 0) {
      this.seconds = -1;
    } else {
      this.seconds = seconds;
    }
    permanent = false;
  }

  public boolean isPermanent() {
    return permanent;
  }

  public int getUnavailableSeconds() {
    return permanent ? -1 : seconds;
  }
}
