/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.       *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.portletcontainer.impl.aop;

import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;
import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;

import org.exoplatform.services.portletcontainer.impl.portletAPIImp.RenderRequestImp;
import org.exoplatform.services.portletcontainer.impl.portletAPIImp.ActionRequestImp;


/*
 * @author: Benjamin Mestrallet
 * @author: Tuan Nguyen
 */

public class PortletMethodCommand extends BaseCommandUnit {

  protected Object render(RenderExecutionContext rcontext)  throws Throwable {
    RenderRequest request = rcontext.request_;
    RenderResponse response = rcontext.response_;
    
    request.setAttribute("javax.portlet.config",((RenderRequestImp)request).getPortletConfig());
    request.setAttribute("javax.portlet.request", request);
    request.setAttribute("javax.portlet.response", response);
    
    rcontext.portlet_.render(request, response) ;
    
    request.removeAttribute("javax.portlet.config");
    request.removeAttribute("javax.portlet.request");
    request.removeAttribute("javax.portlet.response"); 
    
    return null ;
  }
  
  protected Object processAction(ActionExecutionContext acontext)  throws Throwable  {
    ActionRequest request = acontext.request_;
    ActionResponse response = acontext.response_;
    
    request.setAttribute("javax.portlet.config",((ActionRequestImp)request).getPortletConfig());
    request.setAttribute("javax.portlet.request", request);
    request.setAttribute("javax.portlet.response", response);
    
    acontext.portlet_.processAction(acontext.request_, acontext.response_) ;
    
    request.removeAttribute("javax.portlet.config");
    request.removeAttribute("javax.portlet.request");
    request.removeAttribute("javax.portlet.response"); 
    
    return null ;
  }
}