package org.esupportail.cas.server.handlers.ldap;

import org.dom4j.Element;

/**
 * This class implements a fastbind LDAP handler class. It is used by
 * GenericHandler.
 *
 * @author Pascal Aubry <pascal.aubry at univ-rennes1.fr>
 */
public final class FastBindLdapHandler extends LdapHandler {
	
	/**
	 * Constructor.
	 *
	 * @param handlerElement the XML element that declares the handler 
	 * in the configuration file 
	 * @param configDebug debugging mode of the global configuration
	 * @throws Exception Exception
	 */
	public FastBindLdapHandler(
			final Element handlerElement, 
			final Boolean configDebug) throws Exception {
		super(handlerElement, configDebug);
		traceBegin();

		// add the ldap servers
		addServers(true/*serverElementNeeded*/, getClass().getPackage().getName() + ".FastBindLdapServer");

		traceEnd();
	}
	
}

