/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.categorybrowser;

import condition.* ;
import suites.portal.*;
import suites.share.*;
import suites.share.NewAccountSuite;
import suites.share.UserLoginSuite;
import suites.share.UserLogoutSuite;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;

/**
 * Created by The eXo Platform SARL
 * Author : HoaPham
 *          phamvuxuanhoa@yahoo.com
 * Feb 8, 2006
 */

static public class AdminPrepareDataSuite extends WebUnitSuite{
  static String DESC = "Go to ECM File Explorer page to create some data" ;
  static String NAME = "AdminPrepareDataSuite" ;
  
  public AdminPrepareDataSuite(){       
    super(NAME, DESC) ;
    goToPage("/Home/ecm") ;
    addWebUnit(
      new ClickURLLinkUnit("ClickOnProduction", "click on Production button").
      setURL("&uicomponent=UIDriveBrowser&op=selectWorkspace&objectId=production").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=MainToolbar&op=selectDrive"))      
    ) ;    
    //-----Select Actions tab
    addWebUnit(
      new ClickURLLinkUnit("SelectActiontab", "Select Actions tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=UIDefaultAction").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=addDocument"))      
    ) ; 
    //-----Goto /cms/categories/cms/news
    addWebUnit(
      new ClickURLLinkUnit("ClickOnCMS", "click on cms link").
      setURL("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/cms").       
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/cms/home"))      
    ) ; 
      
    addWebUnit(
        new ClickURLLinkUnit("GoTo'/categories' Node", "go to /categories").
        setURL("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/cms/categories")      
      ) ;
    
    addWebUnit(
        new ClickURLLinkUnit("GoTo'/categories/cms' Node", "go to /categories/cms").
        setURL("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/cms/categories/cms")      
      ) ;
    
    addWebUnit(
        new ClickURLLinkUnit("GoTo'../cms/news'Node", "go to /categories/cms/news").
        setURL("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/cms/categories/cms/news")      
      ) ;          
    addWebUnit(
        new ClickURLLinkUnit("AddDocument", "click on Add Document button").
        setURL("&uicomponent=UIToolbar&op=addDocument").                  
        addValidator(new ExpectFormIdValidator("selectContentTypeForm")).
        addValidator(new ExpectFormIdValidator("contentForm"))
    ) ;
    
    addWebUnit(        
        new SubmitFormUnit("SelectDocumentType'nt:file'", "select document type is nt:file").
        setFormId("selectContentTypeForm").   
        setField("contentType","nt:file").
        setField("op","changeType").          
        addValidator(new ExpectTextValidator("File")).
        addValidator(new ExpectTextValidator("Content:"))
    ) ;    
    
    addWebUnit(
        new SubmitFormUnit("SaveFileAsChild", "click on save button").
        setFormId("contentForm").   
        setField("contentName","aChildFile").
        setField("summary","This is the child document of news").      
        setField("op","save").
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIDocumentInfo&op=changeNode&objectId=/cms/categories/cms/news/aChildFile"))
      ) ;      
    //  Save session
    addWebUnit(
        new ClickURLLinkUnit("SavedSession", "click on save Session button").
        setURL("&uicomponent=MainToolbar&op=saveSession").        
        addValidator(new ExpectTextValidator("All the changes have been saved"))      
    ) ;
    addWebSuite(new UserLogoutSuite()) ;
  }        
  public java.util.List getRequiredSuites(){
    String[] roles = ["user", "admin"] ;
    return [new UserLoginSuite(CommonUnit.NAME_EXO_ADMIN, "exo", roles)] ;
  }
}