/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.admin;

import condition.* ;
import suites.share.CommonUnit ;
import suites.share.UserLoginSuite;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import suites.share.UserLogoutSuite;

/**
 *  Need to check that the changes to the script have been taken into accoount 
 *
 *
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class AdminScriptsSuite extends WebUnitSuite {
  static String DESC = "Go to Admin The ECM page, click on Manage Script button and test all the basic actions" ;
  static String NAME = "AdminScriptsSuite" ;
    
  public AdminScriptsSuite() {    
    super(NAME, DESC) ;    
    goToPage("/Home/ecm") ;
    addWebUnit(
      new ClickURLLinkUnit("SelectAdminTheECM", "Select Admin The ECM tab").
      setURL("componentId=ECMPage&portal:action=changeTab&objectId=ecm").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIECMAdminSummary&op=manageTemplates"))      
    ) ;      
    addWebUnit(
      new ClickURLLinkUnit("ManageScripts", "Click on Manage Scripts button").
      setURL("&uicomponent=UIECMAdminSummary&op=manageScripts").                  
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UINode&op=selectNode&objectId=CBScriptManager"))      
    ) ;    
    
    //CB Script Manager
    addWebUnit(
        new ClickURLLinkUnit("CBScriptmanagerTab", "Click on CBScriptmanager tab").
        setURL("uicomponent=UINode&op=selectNode&objectId=CBScriptManager").                  
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UICBScriptList&op=add"))      
    ) ;
    //-----Add a new CBScriptmanager
    addWebUnit(
        new ClickURLLinkUnit("ClickAddIcon", "Click on Add icon").
        setURL("uicomponent=UICBScriptList&op=add").                  
        addValidator(new ExpectFormIdValidator("scriptForm"))      
    ) ;    
    addWebUnit(
        new SubmitFormUnit("CreatCBSciptmanager", "Creat a new CBScriptmanager").
        setFormId("scriptForm").
        setField("content","This is test-CBSciptmanager").                  
        setField("script","test-CBScriptmanager").
        setField("op","save").
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UICBScriptList&op=edit&objectId=test-CBScriptmanager"))           
    ) ;    
    //-----Edit test-CBScriptmanager
    addWebUnit(
        new ClickURLLinkUnit("ClickEditIcon", "Click on edit icon of test-CBScriptmanager").
        setURL("uicomponent=UICBScriptList&op=edit&objectId=test-CBScriptmanager").                  
        addValidator(new ExpectFormIdValidator("scriptForm"))      
    ) ; 
    addWebUnit(
        new SubmitFormUnit("Edittest-CBSciptmanager", "Edit some info of test-CBScriptmanager").
        setFormId("scriptForm").
        setField("content","test-CBSciptmanager-ONE"). 
        setCheckBox("enableVersioning",true).
        setField("op","save").
        addValidator(new ExpectTextValidator("/jcr:system/exo:ecm/scripts/content-browser/test-CBScriptmanager"))           
    ) ;
    //-----Reedit test-CBScriptmanager
    addWebUnit(
        new ClickURLLinkUnit("ReClickEditIcon", "Click on edit icon of test-CBScriptmanager").
        setURL("uicomponent=UICBScriptList&op=edit&objectId=test-CBScriptmanager").  
        addValidator(new ExpectFormIdValidator("selectScriptVersionForm")).  
        addValidator(new ExpectTextValidator("1")).
        addValidator(new ExpectFormIdValidator("scriptForm")).
        addValidator(new ExpectTextValidator("test-CBSciptmanager-ONE")).
        addValidator(new ExpectTextValidator("Enable Versioning"))
    ) ; 
    addWebUnit(
        new SubmitFormUnit("ReEdittest-CBSciptmanager", "Edit some info of test-CBScriptmanager").
        setFormId("scriptForm").
        setField("content","test-CBSciptmanager-TWO").           
        setField("op","save").
        addValidator(new ExpectTextValidator("/jcr:system/exo:ecm/scripts/content-browser/test-CBScriptmanager"))           
    ) ;
    //-----Restore Script Version
    addWebUnit(
        new ClickURLLinkUnit("ReClickEditIcon", "Click on edit icon of test-CBScriptmanager").
        setURL("uicomponent=UICBScriptList&op=edit&objectId=test-CBScriptmanager").            
        addValidator(new ExpectTextValidator("2")).
        addValidator(new ExpectTextValidator("test-CBSciptmanager-TWO")).
        addValidator(new ExpectLinkWithTextValidator("restore"))
    ) ; 
    addWebUnit(
        new SubmitFormUnit("Select version 1", "select version 1 from select box").
        setFormId("selectScriptVersionForm").     
        setField("version","1").
        setField("op","changeVersion").
        addValidator(new ExpectTextValidator("1")).
        addValidator(new ExpectTextValidator("test-CBSciptmanager-ONE"))           
    ) ;     
    addWebUnit(
        new SubmitFormUnit("RestoreVersion", "Click on restore icon").
        setFormId("scriptForm").      
        setField("op","restoreVersion").      
        addValidator(new ExpectTextValidator("The version 1 was restored successfully.")).
        addValidator(new ExpectTextValidator("/jcr:system/exo:ecm/scripts/content-browser/test-CBScriptmanager"))           
    ) ; 
    //-----Delete test-CBScriptmanager
    addWebUnit(
        new ClickURLLinkUnit("Deletetest-CBScriptmanager", "Click on delete icon of test-CBScriptmanager").
        setURL("uicomponent=UICBScriptList&op=delete&objectId=test-CBScriptmanager").                  
        addValidator(new ExpectNoTextValidator("test-CBScriptmanager"))      
    ) ; 
    
    //ECM Scipt Manager
    addWebUnit(
        new ClickURLLinkUnit("ECMScriptmanager", "Click on ECMScriptmanager tab").
        setURL("uicomponent=UINode&op=selectNode&objectId=ECMScriptManager").                  
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIECMScriptList&op=add"))      
    ) ;
    //-----ECMAction--------------------------------------------------
    addWebUnit(
        new SubmitFormUnit("SelectECMAction", "Select type is ECMAction").
        setFormId("scriptFilterForm").
        setField("scriptType","ecm-explorer/action").
        setField("op","changeScriptType").
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIECMScriptList&op=add"))           
    ) ; 
    //----------Add a new ECMSciptmanager with type is ECMAction
    addWebUnit(
        new ClickURLLinkUnit("ClickAddIcon", "Click on Add icon").
        setURL("uicomponent=UIECMScriptList&op=add").                  
        addValidator(new ExpectLinkWithURLValidator("scriptForm"))      
    ) ; 
    addWebUnit(
        new SubmitFormUnit("CreatECMAction", "Creat a new ECMAction").
        setFormId("scriptForm").
        setField("content","This is test-ECMAction").                  
        setField("script","test-ECMAction").
        setField("op","save").
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIECMScriptList&op=edit&objectId=test-ECMAction"))           
    ) ;   
    //----------Edit test-ECMAction
    addWebUnit(
        new ClickURLLinkUnit("ClickEditIcon", "Click on edit icon of test-ECMAction").
        setURL("uicomponent=UIECMScriptList&op=edit&objectId=test-ECMAction").                  
        addValidator(new ExpectLinkWithURLValidator("scriptForm"))      
    ) ; 
    addWebUnit(
        new SubmitFormUnit("SubmitEditECMAction", "Edit ECMAction").
        setFormId("scriptForm").
        setField("content","test-ECMAction-ONE").   
        setCheckBox("enableVersioning",true).
        setField("op","save").
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIECMScriptList&op=edit&objectId=test-ECMAction"))           
    ) ; 
    //----------Reedit test-ECMAction
    addWebUnit(
        new ClickURLLinkUnit("ClickEditIcon", "Click on edit icon of test-ECMAction").
        setURL("uicomponent=UIECMScriptList&op=edit&objectId=test-ECMAction").  
        addValidator(new ExpectFormIdValidator("selectScriptVersionForm")).  
        addValidator(new ExpectTextValidator("1")).
        addValidator(new ExpectFormIdValidator("scriptForm")).
        addValidator(new ExpectTextValidator("test-ECMAction-ONE")).
        addValidator(new ExpectTextValidator("Enable Versioning"))              
    ) ; 
    addWebUnit(
        new SubmitFormUnit("SubmitEditECMAction", "Edit ECMAction").
        setFormId("scriptForm").
        setField("content","test-ECMAction-TWO").                  
        setField("op","save").
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIECMScriptList&op=edit&objectId=test-ECMAction"))           
    ) ; 
    //----------Restore Script Version
    addWebUnit(
        new ClickURLLinkUnit("ClickEditIcon", "Click on edit icon of test-ECMAction").
        setURL("uicomponent=UIECMScriptList&op=edit&objectId=test-ECMAction").          
        addValidator(new ExpectTextValidator("2")).
        addValidator(new ExpectTextValidator("test-ECMAction-TWO")).
        addValidator(new ExpectLinkWithTextValidator("restore"))                
    ) ; 
    addWebUnit(
        new SubmitFormUnit("Select version 1", "select version 1 from select box").
        setFormId("selectScriptVersionForm").     
        setField("version","1").
        setField("op","changeVersion").
        addValidator(new ExpectTextValidator("1")).
        addValidator(new ExpectTextValidator("test-ECMAction-ONE"))           
    ) ;     
    addWebUnit(
        new SubmitFormUnit("RestoreVersion", "Click on restore icon").
        setFormId("scriptForm").      
        setField("op","restoreVersion").      
        addValidator(new ExpectTextValidator("The version 1 was restored successfully.")).
        addValidator(new ExpectTextValidator("/jcr:system/exo:ecm/scripts/ecm-explorer/action/test-ECMAction"))                                                        
    ) ;    
    //----------Delete test-ECMAction
    addWebUnit(
        new ClickURLLinkUnit("Deletetest-ECMAction", "Click on delete icon of test-ECMAction").
        setURL("uicomponent=UIECMScriptList&op=delete&objectId=test-ECMAction").                  
        addValidator(new ExpectNoTextValidator("test-ECMAction"))      
    ) ; 
    //-----ECMInterceptor-----------------------------------------------------
    addWebUnit(
        new SubmitFormUnit("SelectECMInterceptor", "Select type is ECMInterceptor").
        setFormId("scriptFilterForm").
        setField("scriptType","ecm-explorer/interceptor").
        setField("op","changeScriptType").
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIECMScriptList&op=add"))           
    ) ;  
    //-----------Add a new ECMSciptmanager with type is ECMInterceptor
    addWebUnit(
        new ClickURLLinkUnit("ClickAddIcon", "Click on Add icon").
        setURL("uicomponent=UIECMScriptList&op=add").                  
        addValidator(new ExpectLinkWithURLValidator("scriptForm"))      
    ) ; 
    addWebUnit(
        new SubmitFormUnit("CreatECMInterceptor", "Creat a new ECMInterceptor").
        setFormId("scriptForm").
        setField("content","This is test-ECMInterceptor").                  
        setField("script","test-ECMInterceptor").
        setField("op","save").
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIECMScriptList&op=edit&objectId=test-ECMInterceptor"))           
    ) ;  
    //----------Delete test-ECMInterceptor
    addWebUnit(
        new ClickURLLinkUnit("Deletetest-ECMInterceptor", "Click on delete icon of test-ECMInterceptor").
        setURL("uicomponent=UIECMScriptList&op=delete&objectId=test-ECMInterceptor").                  
        addValidator(new ExpectNoTextValidator("test-ECMInterceptor"))      
    ) ;   
    //-----ECMWidget-----------------------------------------------------------
    addWebUnit(
        new SubmitFormUnit("SelectECMWidget", "Select type is ECMWidget").
        setFormId("scriptFilterForm").
        setField("scriptType","ecm-explorer/widget").
        setField("op","changeScriptType").
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIECMScriptList&op=add"))           
    ) ;  
    //-----------Add a new ECMSciptmanager with type is ECMWidget
    addWebUnit(
        new ClickURLLinkUnit("ClickAddIcon", "Click on Add icon").
        setURL("uicomponent=UIECMScriptList&op=add").                  
        addValidator(new ExpectLinkWithURLValidator("scriptForm"))      
    ) ; 
    addWebUnit(
        new SubmitFormUnit("CreatECMWidget", "Creat a new ECMWidget").
        setFormId("scriptForm").
        setField("content","This is test-ECMWidget").                  
        setField("script","test-ECMWidget").
        setField("op","save").
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIECMScriptList&op=edit&objectId=test-ECMWidget"))           
    ) ;
    //----------Delete test-ECMWidget
    addWebUnit(
        new ClickURLLinkUnit("Deletetest-ECMWidget", "Click on delete icon of test-ECMWidget").
        setURL("uicomponent=UIECMScriptList&op=delete&objectId=test-ECMWidget").                  
        addValidator(new ExpectNoTextValidator("test-ECMWidget"))      
    ) ; 
        
    //Back to Admin The ECM
    addWebUnit(
      new ClickURLLinkUnit("ClickOnCancel", "Click on cancel icon").
      setURL("uicomponent=UIECMScriptList&op=back").     
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIECMAdminSummary&op=manageRules"))      
    ) ;    
  }     
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user", "admin"] ;
    return [new UserLoginSuite(CommonUnit.NAME_EXO_ADMIN, "exo", roles)] ;
  }  
}