/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import suites.runner.ECMUserSuites;

/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class UserImportNodeSuite extends WebUnitSuite {
  static String DESC = "Go to Ecm Portlet User page, select Admin tab, click on UserExportNodeSuite button and test all the basic actions" ;
  static String NAME = "UserImportNodeSuite" ;
  String COMMENT  = "You must run AdminViewSuite and AdminDriveSuite before run this suite";
  
  public UserImportNodeSuite() {    
    super(NAME, DESC) ;    
    addWebSuite(new UserAddFolderSuite());
    //-----Select Admin tab
    addWebUnit(
      new ClickURLLinkUnit("SelectAdminTab", "click on Admin tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Admin").             
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=importNode"))
    ) ;     
    //-----Import Node
    addWebUnit(
      new ClickURLLinkUnit("ClickOnImportNode", "click on Import Node button").
      setURL("&uicomponent=UIToolbar&op=importNode").                  
      addValidator(new ExpectFormIdValidator("importForm"))      
    ) ;         
    def is;    
    is = Thread.currentThread().
        getContextClassLoader().
        getResourceAsStream("org/exoplatform/test/web/exported-node.xml") ;        
    addWebUnit(
      new SubmitFormUnit("ImportFileClass", "click on import button").
      setFormId("importForm").   
      setFileField("upload","exported-node.xml", is).
      setField("op","save")
    ) ;
    if (UserECMFileExplorerSuite.isEnableJCR) {
      //Click on preferences icon
      addWebUnit(
        new ClickURLLinkUnit("ClickOnPreferences", "click on preferences icon").
        setURL("uicomponent=MainToolbar&op=preferences").                  
        addValidator(new ExpectFormIdValidator("preferencesForm"))      
      ) ; 
      addWebUnit(
        new SubmitFormUnit("SelectEnableJCRLikeStructure", "Select Enable JCR like structure and save").
        setFormId("preferencesForm").
        setCheckBox("checkbox",true).
        setField("op","save").
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=MainToolbar&op=saveSession"))
      ) ;
      //Save session
      addWebUnit(
        new ClickURLLinkUnit("SavedSession", "click on save Session button").
        setURL("&uicomponent=MainToolbar&op=saveSession").        
        addValidator(new ExpectTextValidator("All the changes have been saved"))      
      ) ;
    }     
    //-----Delete imported node
    addWebUnit(
      new ClickURLLinkUnit("DeleteImportedNode", "delete imported node").
      setURL("&op=removeNode&objectId=/home/users/#{client.name}/test-folder/exported-node").          
      addValidator(new ExpectLinkWithURLValidator("&objectId=/home/users/#{client.name}/test-folder/exported-node",0))            
    ) ;
    if (UserECMFileExplorerSuite.isEnableJCR) {
      //Click on preferences icon
      addWebUnit(
        new ClickURLLinkUnit("ClickOnPreferences", "click on preferences icon").
        setURL("uicomponent=MainToolbar&op=preferences").                  
        addValidator(new ExpectFormIdValidator("preferencesForm"))      
      ) ; 
      addWebUnit(
        new SubmitFormUnit("SelectEnableJCRLikeStructure", "Select Enable JCR like structure and save").
        setFormId("preferencesForm").
        setCheckBox("checkbox",true).
        setField("op","save").
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=MainToolbar&op=saveSession"))
      ) ;
      //Save session
      addWebUnit(
        new ClickURLLinkUnit("SavedSession", "click on save Session button").
        setURL("&uicomponent=MainToolbar&op=saveSession").        
        addValidator(new ExpectTextValidator("All the changes have been saved"))      
      ) ;
    }     
    //Back to home
    addWebUnit(
      new ClickURLLinkUnit("ClickOnHome", "back to home").
      setURL("&uicomponent=UIJCRExplorer&op=changeNode&objectId=/").      
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIContentManager&op=saveNode&objectId=/cms"))            
    ) ;      
    //Select Drive
    addWebUnit(
      new ClickURLLinkUnit("SelectDrive", "select Drive button").
      setURL("&uicomponent=MainToolbar&op=selectDrive").                  
      addValidator(new ExpectTextValidator("Drives"))      
    ) ;      
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}