/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import suites.runner.ECMUserSuites;

/*
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Aug 08, 2005
*/
public class UserLocalNameSortSuite extends WebUnitSuite {
  static String DESC = "Go to Ecm Portlet User page and add multi documents to test-folder " +
      "and test sort nodes by Local Name" ;
  static String NAME = "UserLocalNameSortSuite" ;
  String COMMENT  = "You must run UserAddFolderSuite before run this suite";
    
  public UserLocalNameSortSuite() {    
    super(NAME, DESC) ;
    
    addWebSuite(new UserAddFolderSuite());        
                        //Create multi nodes, they are divided into 2 page
                        //this date will use to test sort nodes by Local Name
    //Select Actions tab
    addWebUnit(
      new ClickURLLinkUnit("SelectActiontab", "Select Actions tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Actions").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=addDocument"))      
    ) ;
    //Add a document with name is a-docTest
    addWebUnit(
      new ClickURLLinkUnit("AddDocument", "click on Add Document button").
      setURL("uicomponent=UIToolbar&op=addDocument").    
      addValidator(new ExpectFormIdValidator("selectContentTypeForm")).
      addValidator(new ExpectFormIdValidator("contentForm"))
    ) ;
    addWebUnit(
      new SubmitFormUnit("SaveNewDocument", "click on save button").
      setFormId("contentForm").   
      setField("contentName","a-test-doc").
      setField("title","a-test-doc").      
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIContentManager&op=editDocument&objectId=/home/users/#{client.name}/test-folder/a-test-doc"))                                                   
    ) ;       
    //Add 30 document with name are test-doc1,..,test-doc30
    for ( i in 1..30){ 
      //Click on Add document
      addWebUnit(
        new ClickURLLinkUnit("AddDocument", "click on Add Document button").
        setURL("uicomponent=UIToolbar&op=addDocument").    
        addValidator(new ExpectFormIdValidator("selectContentTypeForm")).
        addValidator(new ExpectFormIdValidator("contentForm"))
      ) ;
      //----------Save New Document
      addWebUnit(
        new SubmitFormUnit("SaveNewDocument", "click on save button").
        setFormId("contentForm").   
        setField("contentName","test-doc"+i).
        setField("title","title"+i).      
        setField("op","save").
        addValidator(new ExpectLinkWithURLValidator("uicomponent=UIContentManager&op=editDocument&objectId=/home/users/#{client.name}/test-folder/test-doc"))                                                   
      ) ;                           
    }        
    //Add a document with name is z-docTest
    addWebUnit(
      new ClickURLLinkUnit("AddDocument", "click on Add Document button").
      setURL("uicomponent=UIToolbar&op=addDocument").    
      addValidator(new ExpectFormIdValidator("selectContentTypeForm")).
      addValidator(new ExpectFormIdValidator("contentForm"))
    ) ;
    addWebUnit(
      new SubmitFormUnit("SaveNewDocument", "click on save button").
      setFormId("contentForm").   
      setField("contentName","z-test-doc").
      setField("title","z-test-doc").      
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIContentManager&op=editDocument&objectId=/home/users/#{client.name}/test-folder/z-test-doc"))                                                   
    ) ;  
    if (UserECMFileExplorerSuite.isEnableJCR) {
      //Click on preferences icon
      addWebUnit(
        new ClickURLLinkUnit("ClickOnPreferences", "click on preferences icon").
        setURL("uicomponent=MainToolbar&op=preferences").                  
        addValidator(new ExpectFormIdValidator("preferencesForm"))      
      ) ; 
      addWebUnit(
        new SubmitFormUnit("SelectEnableJCRLikeStructure", "Select Enable JCR like structure and save").
        setFormId("preferencesForm").
        setCheckBox("checkbox",true).
        setField("op","save").
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=MainToolbar&op=saveSession"))
      ) ;
      //Save session
      addWebUnit(
        new ClickURLLinkUnit("SavedSession", "click on save Session button").
        setURL("&uicomponent=MainToolbar&op=saveSession").        
        addValidator(new ExpectTextValidator("All the changes have been saved"))      
      ) ;
    }     
                        //Test sort nodes by Local Name    
    //-----Descending sort
    addWebUnit(
      new ClickURLLinkUnit("DescendingSort", "click on Descending Sort icon").
      setURL("&uicomponent=UIContentManager&op=sort&objectId=Alphabetic;Descending").                
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIContentManager&op=editDocument&objectId=/home/users/#{client.name}/test-folder/z-test-doc"))      
    ) ; 
    //-----Ascending sort
    addWebUnit(
      new ClickURLLinkUnit("AscendingSort", "click on Ascending Sort icon").
      setURL("&uicomponent=UIContentManager&op=sort&objectId=Alphabetic;Ascending").              
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIContentManager&op=editDocument&objectId=/home/users/#{client.name}/test-folder/a-test-doc"))                                             
    ) ;   
    //Return to workspace selection
    addWebUnit(
      new ClickURLLinkUnit("SelectDrive", "select Drive button").
      setURL("&uicomponent=MainToolbar&op=selectDrive").                  
      addValidator(new ExpectTextValidator("Drives"))      
    ) ; 
    
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}