/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import suites.runner.ECMUserSuites;

/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class UserSignatureNodeSuite extends WebUnitSuite {
  static String DESC = "Go to Ecm Portlet User page, select Admin tab, click on Signature button and test all the basic actions" ;
  static String NAME = "UserSignatureNodeSuite" ;
  String COMMENT  = "You must run AdminViewSuite and AdminDriveSuite before run this suite";
  
  public UserSignatureNodeSuite() {    
    super(NAME, DESC) ;    
    addWebSuite(new UserAddFolderSuite());
    //-----Select Action tab    
    addWebUnit(
      new ClickURLLinkUnit("SelectActionTab", "click on Action tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Action").             
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=upload"))                      
    ) ;             
    //Upload a file to created Folder
    addWebUnit(
      new ClickURLLinkUnit("UploadFileToFolder", "click on Upload button").
      setURL("&uicomponent=UIToolbar&op=upload").                  
      addValidator(new ExpectFormIdValidator("uploadForm"))      
    ) ;
    //-----Save File
    def is;
    is= Thread.currentThread().
        getContextClassLoader().
        getResourceAsStream("META-INF/maven/exo-test/exo-test.webunit-framework/pom.xml") ;    
    
    addWebUnit(
      new SubmitFormUnit("SaveFile", "click on save button").
      setFormId("uploadForm").   
      setField("name","file-upload-name").    
      setFileField("upload","pom.xml", is).
      setField("op","save").
      addValidator(new ExpectTextValidator("file-upload-name"))           						   
    ) ;        
    addWebUnit(
      new ClickLinkWithText("ClickOnUploadedFile", "click on uploaded file").      
      setTextLink("file-upload-name")	  
    ) ;  
     
    addWebUnit(
      new SubmitFormUnit("SelectSimpleView", "select simple view").
      setFormId("UISelectViewForm").             
      setField("views","simple-view").
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=addSignature"))      
    ) ;     
    //Click on Add Signature
    addWebUnit(
      new ClickURLLinkUnit("ClickOnAddSignature", "click on add signature").
      setURL("&uicomponent=UIToolbar&op=addSignature").            	       	      
      addValidator(new ExpectTextValidator("Add digital signature"))
    ) ;    
    //Click on Sign link
    addWebUnit(
      new ClickLinkWithText("ClickOnSignLink", "click on Sign link").      
      setTextLink("Sign").
      addValidator(new ExpectFormNameValidator("SelectKeyStoreForm"))
    ) ;
    //Click on OK button
    addWebUnit(
      new TODO("can'tClickOKButton", COMMENT).
      setComment(COMMENT).
      setStatus(WebUnit.STATUS_INCOMPLETE)
    ) ;       
    /*
    def is1;
    is1= Thread.currentThread().
        getContextClassLoader().
        getResourceAsStream("META-INF/maven/exo-test/exo-test.webunit-framework/exouser.pfx") ;    
    
    addWebUnit(
      new SubmitFormUnit("SaveFile", "click on save button"). 
      setFormId("SelectKeyStoreForm").   
      setFileField("keystore","exouser.pfx", is1).
      setField("pwd","exo").
      setField("check","exo").      
      setSubmitButton("SelectKeyStoreForm").
      addValidator(new ExpectLinkWithURLValidator("The node exouser.pfx was signed successful."))
    ) ;    
    */        
    //Back to home
    addWebUnit(
      new ClickURLLinkUnit("ClickOnHome", "back to home").
      setURL("&uicomponent=UIJCRExplorer&op=changeNode&objectId=/")                  
    ) ;       
    //Select Drive
    addWebUnit(
      new ClickURLLinkUnit("SelectDrive", "select Drive button").
      setURL("&uicomponent=MainToolbar&op=selectDrive").                  
      addValidator(new ExpectTextValidator("Drives"))      
    ) ;              
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}