/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Jan 24, 2007
 */
public class UserViewMetadatasSuite extends WebUnitSuite {
  static String DESC = "Go to View Metadats page and test all the basic actions" ;
  static String NAME = "UserViewMetadatasSuite" ;  
  String COMMENT  = "You must run AdminManageTaxonomySuite, AdminViewSuite and AdminDriveSuite before run this suite";
  
  public UserViewMetadatasSuite() {    
    super(NAME, DESC) ;
    addWebSuite(new UserAddFolderSuite());            
    //-----Create a nt:file node
    addWebUnit(
      new ClickURLLinkUnit("SelectActiontab", "Select Actions tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Actions").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=addFolder"))      
    ) ;    
    addWebUnit(
      new ClickURLLinkUnit("ClickOnAddDocument", "click on add document icon").
      setURL("&uicomponent=UIToolbar&op=addDocument").                  
      addValidator(new ExpectFormIdValidator("contentForm"))      
    ) ;        
    //-----Add new Nt:file document
    addWebUnit(
      new SubmitFormUnit("SelectFile", "select document type is File").
      setFormId("selectContentTypeForm").   
      setField("contentType","nt:file").
      setField("op","changeType").
      addValidator(new ExpectNoTextValidator("Summary"))      
    ) ;    
    //----------Save New Document
    addWebUnit(
      new SubmitFormUnit("SaveNewDocument", "click on save button").
      setFormId("contentForm").   
      setField("contentName","nt:file-name").
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIContentManager&op=editDocument&objectId=/home/users/#{client.name}/test-folder/nt:file-name"))                                                   
    ) ;      
    if (UserECMFileExplorerSuite.isEnableJCR) {
      //Click on preferences icon
      addWebUnit(
        new ClickURLLinkUnit("ClickOnPreferences", "click on preferences icon").
        setURL("uicomponent=MainToolbar&op=preferences").                  
        addValidator(new ExpectFormIdValidator("preferencesForm"))      
      ) ; 
      addWebUnit(
        new SubmitFormUnit("SelectEnableJCRLikeStructure", "Select Enable JCR like structure and save").
        setFormId("preferencesForm").
        setCheckBox("checkbox",true).
        setField("op","save").
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=MainToolbar&op=saveSession"))
      ) ;
      //Save session
      addWebUnit(
        new ClickURLLinkUnit("SavedSession", "click on save Session button").
        setURL("&uicomponent=MainToolbar&op=saveSession").        
        addValidator(new ExpectTextValidator("All the changes have been saved"))      
      ) ;
    } 
    //-----Add metadata for nt:file created node
    addWebUnit(
      new ClickURLLinkUnit("ClickOnCreatedNode", "click on nt:file created node").
      setURL("&uicomponent=UIContentManager&op=changeNode&objectId=/home/users/#{client.name}/test-folder/nt:file-name").
      addValidator(new ExpectTextValidator("File Content"))      
    ) ;    
    addWebUnit(
      new ClickURLLinkUnit("SelectInfoTab", "click on info tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Info").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=viewProperties"))
    ) ;
    addWebUnit(
      new ClickURLLinkUnit("ClickOnViewMetadatas", "click on View Metadatas icon").
      setURL("&uicomponent=UIToolbar&op=viewMetadatas").        
      addValidator(new ExpectTextValidator("Metadata elements"))      
    ) ;      
    addWebUnit(
      new SubmitFormUnit("Add/editProperties", "Click add/edit properties icon").
      setFormId("uiMetadataForm").      
      setField("op","addMetadata").
      addValidator(new ExpectTextValidator("Metadata name:"))
    ) ;
    addWebUnit(
      new SubmitFormUnit("Save", "Click save button").
      setFormId("uiMetadataForm").      
      setField("metadataType","dc:elementSet").
      setField("title","metadata-title").
      setField("op","save").
      addValidator(new ExpectTextValidator("DC:ELEMENTSET")).
      addValidator(new ExpectTextValidator("metadata-title")).
      addValidator(new ExpectTextValidator("add/edit properties"))
    ) ;
    //Select Drive
    addWebUnit(
      new ClickURLLinkUnit("SelectDrive", "select Drive button").
      setURL("&uicomponent=MainToolbar&op=selectDrive").                  
      addValidator(new ExpectTextValidator("Drives"))      
    ) ;           
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}