alias ls="ls --color"

alias cdhome="cd ~"
alias cdwinhome="cd $USER_HOME"
alias cdback='cd  $OLDPWD'
alias cdv2x="cd $EXO_SRC_CODE"
alias cdexo-platform="cd $EXO_SRC_CODE/exo-platform"
alias cdexo-portal="cd $EXO_SRC_CODE/exo-portal"
alias cdexo-ecm="cd $EXO_SRC_CODE/exo-ecm"
alias cdexo-test="cd $EXO_SRC_CODE/exo-test"
alias cdbasedir="cd $BASE_DIRECTORY"

alias mvnrepoclean="rm -rf $M2_REPO/exo*"

alias mvnexorelease="cd $EXO_SRC_CODE && mvn -f exo-tools/build/config/pom.xml exo:release " 

alias mvnmodulecleaninstall="mvn clean install"
alias mvnmoduledeploy="mvn clean install exo:deploy "
alias mvnmoduledeployall="mvn clean install exo:deploy "


alias mvninstallpluginexo="cd $EXO_SRC_CODE/exo-tools/maven2/plugins/exo && mvn install"

alias mvnv2xclean="cdv2x && mvn -f working-modules.xml clean"

alias mvnworkingbuild="cdv2x && mvn -f working-modules.xml clean install"

alias mvnworkingeclipse="cdv2x && mvn -f working-modules.xml eclipse:clean eclipse:eclipse"

alias mvnportaldeploy="cdv2x &&  mvn -f  exo-portal/product-exo-portal.xml -Dclean deploy"

alias mvnportaltest="cd $EXO_SRC_CODE/exo-test/webunit-suites && mvn exo:execute && cdback"

alias mvnecmtest="cd $EXO_SRC_CODE/exo-test/webunit-suites && mvn exo:execute -DexecuteId=ecm && cdback"
                    
alias mvnecmdeploy="cdv2x &&  mvn -f  exo-ecm/product-exo-ecm.xml -Dclean deploy"

alias mvnldapdeploy="cd $EXO_SRC_CODE/exo-platform/services/ldap/api &&
                     mvnmoduledeploy &&
                     cd ../impl &&
                     mvnmoduledeploy &&
                     cd $EXO_WORKING_DIR/exo-tomcat/webapps/portal/WEB-INF/conf &&
                     cp -fv $EXO_SRC_CODE/exo-platform/services/organization/impl/src/java/conf/portal/ldap-organization-configuration.xml . "

alias svnupdatev2x="mvnv2xclean && svn update *"

alias vibuild="vi $USER_HOME/build.properties"
alias visetting="vi $USER_HOME/.m2/settings.xml"

alias sql="mysql -t -u dev -pdev dev"

alias ldap=" cd /cygdrive/c/openldap && ./slapd -d 1 "

alias cdtomcat="cd $EXO_WORKING_DIR/exo-tomcat"
alias cdtomcatbin="cd $EXO_WORKING_DIR/exo-tomcat/bin"
alias tomcatClean="cd $EXO_WORKING_DIR/exo-tomcat/bin &&
                   rm -rf ../temp/* &&
                   rm -rf ../work/* &&
                   rm -rf ../logs/* "
   
alias tomcatRun="cd $EXO_WORKING_DIR/exo-tomcat/bin && chmod +x *.sh && ./exo-run.sh "

alias tomcatCleanRun="cd $EXO_WORKING_DIR/exo-tomcat/bin &&
		                  rm -rf ../temp/* &&
                      rm -rf ../work/* &&
                      rm -rf ../logs/*  &&
                      chmod +x *.sh && ./exo-run.sh "


alias tomcatPortletDeploy="mvn compile  jar:jar && 
                           cp target/*.jar  src/webapp/WEB-INF/lib/"

alias tomcatContextDeploy="cp src/resources/tomcat/*.xml  $EXO_WORKING_DIR/exo-tomcat/conf/Catalina/localhost/"
# JOnAS aliases

alias cdjonas="cd $EXO_WORKING_DIR/exo-jonas"

alias mvnjonasportaldeploy="cdv2x &&  mvn -P jonas-server -f  exo-portal/product-exo-portal.xml -Dclean deploy"
alias mvnjonasecmdeploy="cdv2x &&  mvn -P jonas-server -f  exo-ecm/product-exo-ecm.xml -Dclean deploy"
alias mvnjonasecmbonitadeploy="cdv2x &&  mvn -P jonas-server -f exo-ecm/product-exo-ecm-bonita.xml -Dclean deploy"
alias mvnjonasbideploy="cdv2x &&  mvn -P jonas-server -f  exo-bi/product-exo-bi.xml -Dclean deploy"
alias mvnjonasmoduledeploy="mvn -P jonas-server clean install exo:deploy "

alias jonasStart="cd $EXO_WORKING_DIR/exo-jonas/bin/unix && chmod +x jonas && ./jonas start "
alias jonasCleanStart="cd $EXO_WORKING_DIR/exo-jonas/bin/unix && chmod +x jonas && rm -rf ../../temp/* && rm -rf ../../work/* && rm -rf ../../logs/* && ./jonas start "
alias jonasStop="cd $EXO_WORKING_DIR/exo-jonas/bin/unix && ./jonas stop "

#Local server  client  synch
alias clientserversyncdoc="rsync -rav --delete $BASE_DIRECTORY/projects/eXo-Data/eXo-Documents $LOCAL_SERVER_USER@$LOCAL_SERVER_IP:/home/$LOCAL_SERVER_USER/java/projects/eXo-Data/eXo-Documents"
alias clientserversyncdesigns="rsync -rav --delete $BASE_DIRECTORY/projects/eXo-Data/eXo-Designs $LOCAL_SERVER_USER@$LOCAL_SERVER_IP:/home/$LOCAL_SERVER_USER/java/projects/eXo-Data/eXo-Designs"

alias serverclientsyncdoc="rsync -rav --delete $LOCAL_SERVER_USER@$LOCAL_SERVER_IP:/home/$LOCAL_SERVER_USER/java/projects/eXo-Data/eXo-Documents $BASE_DIRECTORY/projects/eXo-Data/eXo-Documents"
alias serverclientsyncdesigns="rsync -rav --delete $LOCAL_SERVER_USER@$LOCAL_SERVER_IP:/home/$LOCAL_SERVER_USER/java/projects/eXo-Data/eXo-Documents $BASE_DIRECTORY/projects/eXo-Data/eXo-Documents"
                      

function svnadd() {
  eval "svn st | grep '^?$1' | sed -e 's/^?    /svn add/g'" 
}

function svnrmdelete() {
  eval "svn st | grep '^!' | sed -e 's/^!    /svn rm/g'" 
}

function svnrm() {
  eval "svn st | grep '$1' | sed -e 's/^    /svn rm/g'" 
}
